--Run SLH_Config_Lua  	
	SLH_NL_Lua = CreateFrame("Frame", "SLH_NL_Lua")
	SLH_NL_Lua:RegisterEvent("ADDON_LOADED")
	SLH_NL_Lua:HookScript("OnEvent", function (self, event, name, ...)
		if (name ~= "SalensLittleHelper") then return end

		--Theoretically speeds up access to global variables by making them local.  This is supposed to be faster.  I have no proof this is true.	
			local _G_SLH = _G 

		local SLH_PCSV_UnitName = _G_SLH["SLH_PCSV"]["SLH_PCSV_UnitNameGlobal"]
		local NL_Profile = _G_SLH["SLH_PCSV"][SLH_PCSV_UnitName]["Config"]["NL_Profile"]
			
		--Development Mode Boolean (Controls various Overrides, disable to test and distribute.)
			local SLH_NL_DevMode = false
			--[[DevMode]]if SLH_NL_DevMode and name ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NL_Lua addonName: " .. name) end	

		-- Set Variables
			local SLH_NL_SetVars = function (self, event, name, ...)
				-- Test/Create SLH_SV Table			
					if _G_SLH["SLH_SV"] == nil then _G_SLH["SLH_SV"] = {} end			
				-- Test/Create SLH_SV.NL_Profile Table
					if _G_SLH["SLH_SV"][NL_Profile] == nil then _G_SLH["SLH_SV"][NL_Profile] = {}  end	
				-- Test/Create SLH_NL Table
					if _G_SLH["SLH_SV"][NL_Profile]["NL"] == nil then _G_SLH["SLH_SV"][NL_Profile]["NL"] = {}  end	
				
				-- NewLootablesButtonLocation			
				
						
				-- Test/Create SLH_NL Variables
					if _G_SLH["SLH_SV"][NL_Profile]["NL"]["Enable"] == nil then _G_SLH["SLH_SV"][NL_Profile]["NL"]["Enable"] = "Y" end
					if _G_SLH["SLH_SV"][NL_Profile]["NL"]["xOfs"] == nil then _G_SLH["SLH_SV"][NL_Profile]["NL"]["xOfs"] = 40 end	
					if _G_SLH["SLH_SV"][NL_Profile]["NL"]["yOfs"] == nil then _G_SLH["SLH_SV"][NL_Profile]["NL"]["yOfs"] = 320 end				
					if _G_SLH["SLH_SV"][NL_Profile]["NL"]["framelevel"] == nil then _G_SLH["SLH_SV"][NL_Profile]["NL"]["framelevel"] = 9000 end		
					if _G_SLH["SLH_SV"][NL_Profile]["NL"]["DisableForCrafting"] == nil then _G_SLH["SLH_SV"][NL_Profile]["NL"]["DisableForCrafting"] = "Y" end
					if _G_SLH["SLH_SV"][NL_Profile]["NL"]["DisableWhenMailBoxIsOpen"] == nil then _G_SLH["SLH_SV"][NL_Profile]["NL"]["DisableWhenMailBoxIsOpen"] = "Y" end
					if _G_SLH["SLH_SV"][NL_Profile]["NL"]["LogOnScan"] == nil then _G_SLH["SLH_SV"][NL_Profile]["NL"]["LogOnScan"] = "Y" end
					
				--Reset Pauses on load
					_G_SLH["SLH_SV"][NL_Profile]["NL"]["PostCombatList"] = {}
					_G_SLH["SLH_SV"][NL_Profile]["NL"]["PausedWhileMailing"] = "N"
			
			end
				
		--SLH_NL Module
			local SLH_NL_Module = function (self, event, SLH_NL_itemLink, SLH_NL_lootstring)
				local SLH_Bags = {}	
				SLH_Bags[1]=0
				SLH_Bags[2]=1
				SLH_Bags[3]=2
				SLH_Bags[4]=3
				SLH_Bags[5]=4
				for index, SLH_bagID in ipairs(SLH_Bags) do
					local SLH_Bag_numberOfSlots = GetContainerNumSlots(SLH_bagID)
					for SLH_slot = 1, SLH_Bag_numberOfSlots do
						local SLH_icon, 
							SLH_itemCount,
							SLH_locked, 
							SLH_quality, 
							SLH_readable, 
							SLH_lootable, --Lockbox ID?
							SLH_itemLink, 
							SLH_isFiltered, 
							SLH_noValue, 
							SLH_itemID = GetContainerItemInfo(SLH_bagID, SLH_slot)
						
						if SLH_itemLink ~= nil and SLH_lootable and SLH_itemLink == SLH_NL_itemLink 
						then 
							local SLH_itemName, 
								SLH_itemLink_GetItemInfo, 
								SLH_itemRarity, 
								SLH_itemLevel, 
								SLH_itemMinLevel, 
								SLH_itemType, 
								SLH_itemSubType, 
								SLH_itemStackCount,
								SLH_itemEquipLoc, 
								SLH_itemIcon, 
								SLH_itemSellPrice, 
								SLH_itemClassID, 
								SLH_itemSubClassID, 
								SLH_bindType, 
								SLH_expacID, 
								SLH_itemSetID, 
								SLH_isCraftingReagent = GetItemInfo(SLH_itemLink) 
					
							local SLH_GetDetailedItemLevelInfo_effectiveILvl, 
								SLH_isPreview, 
								SLH_baseILvl = GetDetailedItemLevelInfo(SLH_NL_itemLink)
									
							--[[DevMode]]if SLH_NL_DevMode and SLH_lootable and SLH_itemLink ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NL: " .. SLH_itemLink.. " is Lootable") end
							--[[DevMode]]if SLH_NL_DevMode and SLH_itemLink ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NL SLH_itemType: " .. SLH_itemType) end
							--[[DevMode]]if SLH_NL_DevMode and SLH_itemSubType ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NL SLH_itemType: " .. SLH_itemSubType) end
							
							
							if tonumber(SLH_itemMinLevel) <= UnitLevel("player")
							then 			
								if UnitAffectingCombat("player")
								then	
									--[[DevMode]]if SLH_NL_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: Unit is in Combat, added to PostCombatList.") end
									local slh_newEntry = #_G_SLH["SLH_SV"][NL_Profile]["NL"]["PostCombatList"]+1
									_G_SLH["SLH_SV"][NL_Profile]["NL"]["PostCombatList"][slh_newEntry] = {}
									_G_SLH["SLH_SV"][NL_Profile]["NL"]["PostCombatList"][slh_newEntry][1] = SLH_NL_itemLink
									_G_SLH["SLH_SV"][NL_Profile]["NL"]["PostCombatList"][slh_newEntry][2] = SLH_NL_lootstring
									return 
								end
								
								if _G_SLH["SLH_SV"][NL_Profile]["NL"]["framelevel"] > 10000
								then	
									_G_SLH["SLH_SV"][NL_Profile]["NL"]["framelevel"] = 9000
								else 
									_G_SLH["SLH_SV"][NL_Profile]["NL"]["framelevel"] = _G_SLH["SLH_SV"][NL_Profile]["NL"]["framelevel"] + 1									
								end	
								
								local SLH_NL_SecureActionButton = CreateFrame("CheckButton", nil, UIParent, "SecureActionButtonTemplate,ActionButtonTemplate")
								SLH_NL_SecureActionButton:SetPoint("CENTER", UIParent, _G_SLH["SLH_SV"][NL_Profile]["NL"]["xOfs"], _G_SLH["SLH_SV"][NL_Profile]["NL"]["yOfs"])	
								SLH_NL_SecureActionButton:SetAttribute("type1", "item")
								SLH_NL_SecureActionButton:SetAttribute("item", SLH_itemName)
								SLH_NL_SecureActionButton:RegisterForClicks("AnyUp")
								SLH_NL_SecureActionButton:SetSize(40, 40)
								SLH_NL_SecureActionButton:SetFrameLevel(_G_SLH["SLH_SV"][NL_Profile]["NL"]["framelevel"])
								
								local SLH_icon = SLH_NL_SecureActionButton:CreateTexture(nil, "ARTWORK")
								SLH_icon:SetAllPoints(true)
								SLH_icon:SetTexture(GetItemIcon(SLH_itemID))
								SLH_NL_SecureActionButton.icon = SLH_icon										 
								SLH_NL_SecureActionButton:Show()
									
								--Make Dragable
								SLH_NL_SecureActionButton:SetMovable(true)
								SLH_NL_SecureActionButton:EnableMouse(true)					
								SLH_NL_SecureActionButton:RegisterForDrag("LeftButton")
								SLH_NL_SecureActionButton:SetScript("OnDragStart", SLH_NL_SecureActionButton.StartMoving)
								SLH_NL_SecureActionButton:SetScript("OnDragStop", SLH_NL_SecureActionButton.StopMovingOrSizing)
																
								SLH_NL_SecureActionButton:HookScript("OnClick", function (self, button, down)   
									if SLH_NL_DevMode and SLH_NL_itemLink ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NL: SLH_NL_itemLink" .. SLH_NL_itemLink) end
									C_Timer.After(.2, function() 
										if button == "RightButton" or GetItemCount(SLH_NL_itemLink) == 0
										then
											self:Hide() 
											RegisterAttributeDriver(self,"visibility","[combat]hide;hide")
											if SLH_NL_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NL: Here1") end
											return	
										else
											C_Timer.After(1, function() 
												if GetItemCount(SLH_NL_itemLink) == 0
												then
													self:Hide() 
													RegisterAttributeDriver(self,"visibility","[combat]hide;hide")
													if SLH_NL_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NL: Here2") end
													return	
												else
													C_Timer.After(1, function() 
														if GetItemCount(SLH_NL_itemLink) == 0
														then
															self:Hide() 
															RegisterAttributeDriver(self,"visibility","[combat]hide;hide")
															if SLH_NL_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NL: Here3") end
															return	
														else
															C_Timer.After(1, function() 
																if GetItemCount(SLH_NL_itemLink) == 0
																then
																	self:Hide() 
																	RegisterAttributeDriver(self,"visibility","[combat]hide;hide")
																	if SLH_NL_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NL: Here4") end
																	return													
																end									
															end)
														end									
													end)
												end									
											end)
										end									
									end)
								end)
								
								SLH_NL_SecureActionButton:HookScript("OnEnter", function(widget)
									GameTooltip:SetOwner(SLH_NL_SecureActionButton, "ANCHOR_RIGHT")
									GameTooltip:SetHyperlink(SLH_NL_itemLink)
									GameTooltip:AddLine("\n\nSLH_NL:\n  Left Click: Use ".. SLH_NL_itemLink .. "\n  Right Click: Hide Button\n  Hold Left Button and Drag to move to your preferred location.", _G_SLH["SLH_SF"]["SLH_TooltipColors"].r, _G_SLH["SLH_SF"]["SLH_TooltipColors"].g, _G_SLH["SLH_SF"]["SLH_TooltipColors"].b, true)
									GameTooltip:Show()
								end)
								SLH_NL_SecureActionButton:HookScript("OnLeave", function(widget) 
									GameTooltip:Hide()
									local SLH_point, SLH_relativeTo, SLH_relativePoint,SLH_xOfs, SLH_yOfs = SLH_NL_SecureActionButton:GetPoint(n)
									
									_G_SLH["SLH_SV"][NL_Profile]["NL"]["xOfs"] = SLH_xOfs
									_G_SLH["SLH_SV"][NL_Profile]["NL"]["yOfs"] = SLH_yOfs
								end)
								
								RegisterAttributeDriver(SLH_NL_SecureActionButton,"visibility","[combat]hide;show")
								
								return
							else
								--[[DevMode]]if SLH_NL_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NL: Item level too high to open.") end
								return
							end
						end
					end
				end
				return
			end

		--SLH_NL Delay
			local SLH_NL_Delay = function (self, event, ...)		
				--[[DevMode]]if SLH_NL_DevMode and event ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NL: " .. event) end
				if event == "MAIL_SHOW" 
				then  
					_G_SLH["SLH_SV"][NL_Profile]["NL"]["PausedWhileMailing"] = "Y"
					return 
				elseif event == "MAIL_CLOSED" 
				then  
					_G_SLH["SLH_SV"][NL_Profile]["NL"]["PausedWhileMailing"] = "N"
					return 
				end	
				if _G_SLH["SLH_SV"][NL_Profile]["NL"]["DisableWhenMailBoxIsOpen"] == "Y" and _G_SLH["SLH_SV"][NL_Profile]["NL"]["PausedWhileMailing"] == "Y" then return end	
				if IsAltKeyDown() then return end
				
				
				local SLH_NL_lootstring, 
					SLH_playerName , 
					SLH_languageName , 
					SLH_channelName , 
					SLH_playerName2 , 
					SLH_specialFlags , 
					SLH_zoneChannelID , 
					SLH_channelIndex , 
					SLH_channelBaseName , 
					unused , 
					SLH_lineID , 
					SLH_SenderGUID, 
					SLH_bnSenderID , 
					SLH_isMobile  , 
					SLH_isSubtitle  , 
					SLH_hideSenderInLetterbox  , 
					SLH_supressRaidIcons  = ...
				local SLH_NL_itemLink = string.match(SLH_NL_lootstring,"|%x+|Hitem:.-|h.-|h|r")
				local SLH_UnitName = string.gsub(UnitName("player"), " ", "")
				local SLH_realmName = string.gsub(GetRealmName(), " ", "")
				local SLH_UnitName_realmName = SLH_UnitName .. "-" .. SLH_realmName
				SLH_playerName = string.gsub(SLH_playerName, " ", "")
				
				if SLH_UnitName_realmName ~= SLH_playerName then return end
				--[[DevMode]]--if SLH_NL_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NL: Player and Realm Name Match") end			
				
				if _G_SLH["SLH_SV"][NL_Profile]["NL"]["DisableForCrafting"] == "Y" and string.find(SLH_NL_lootstring, "You create") then return end
				--[[DevMode]]if SLH_NL_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NL: Not a Crafted Item") end			
				
				if _G_SLH["SLH_SV"][NL_Profile]["NL"]["DisableWhenMailBoxIsOpen"] == "Y" and MailFrame:IsVisible() then return end
				--[[DevMode]]if SLH_NL_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NL: Not a Mailed Item") end
				
				
				C_Timer.After(1, function() SLH_NL_Module(self, event, SLH_NL_itemLink, SLH_NL_lootstring) end) 
				return
			end

		--SLH_NewEquipables Module
			_G_SLH["SLH_SF"]["SLH_NL_Delay2"] = function (self, event, SLH_NL_itemLink, SLH_NL_lootstring)
				if UnitAffectingCombat("player")
				then	
					--[[DevMode]]if SLH_NL_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NL: Unit is in Combat.") end
					C_Timer.After(1, function() _G_SLH["SLH_SF"]["SLH_NL_Delay2"](self, event, SLH_NL_itemLink, SLH_NL_lootstring) end)
					return 
				else 
					C_Timer.After(1, function() SLH_NL_Module(self, event, SLH_NL_itemLink, SLH_NL_lootstring) end)	
					return 
				end
			end

		--SLH_NL_PostCombat
			_G_SLH["SLH_SF"]["SLH_NL_PostCombat"] = function (self, event, SLH_NL_itemLink, SLH_NL_lootstring)				
				if next(_G_SLH["SLH_SV"][NL_Profile]["NL"]["PostCombatList"]) ~= nil
				then
					for i=#_G_SLH["SLH_SV"][NL_Profile]["NL"]["PostCombatList"],1,-1 do	
						C_Timer.After(1, function() 
							if _G_SLH["SLH_SV"][NL_Profile]["NL"]["PostCombatList"][i] ~= nil
							then				
								local SLH_NL_itemLink = _G_SLH["SLH_SV"][NL_Profile]["NL"]["PostCombatList"][i][1]
								local SLH_NL_lootstring = _G_SLH["SLH_SV"][NL_Profile]["NL"]["PostCombatList"][i][2]
								--[[DevMode]]if SLH_NL_DevMode and i ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NL: PostCombat index = " .. i) end	
								--[[DevMode]]if SLH_NL_DevMode and SLH_NL_itemLink ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NL: PostCombat SLH_NL_itemLink = " .. SLH_NL_itemLink) end	
								--[[DevMode]]if SLH_NL_DevMode and SLH_NL_lootstring ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NL: PostCombat SLH_NL_lootstring = " .. SLH_NL_lootstring) end									
								if _G_SLH["SLH_SV"][NL_Profile]["NL"]["PostCombatList"][i][1] ~= nil and _G_SLH["SLH_SV"][NL_Profile]["NL"]["PostCombatList"][i][2]
								then	
									_G_SLH["SLH_SF"]["SLH_NL_Delay2"](self, event, SLH_NL_itemLink, SLH_NL_lootstring) 	
								end								
							end 
							_G_SLH["SLH_SV"][NL_Profile]["NL"]["PostCombatList"][i][1] = nil;
							_G_SLH["SLH_SV"][NL_Profile]["NL"]["PostCombatList"][i][2] = nil;
							_G_SLH["SLH_SV"][NL_Profile]["NL"]["PostCombatList"][i]	 = nil;
							return
						end)
					end	
					return	
				end 	
			end


		--SLH_NC Module Scan
			_G_SLH["SLH_SF"]["SLH_NL_Scan"] = function (self, event, ...)	
		
				--[[DevMode]]if SLH_NL_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: SLH_NL_Module_Scan Start") end		
				local SLH_Bags = {}	
				SLH_Bags[1]=0
				SLH_Bags[2]=1
				SLH_Bags[3]=2
				SLH_Bags[4]=3
				SLH_Bags[5]=4
				for index, SLH_bagID in ipairs(SLH_Bags) do
					local SLH_Bag_numberOfSlots = GetContainerNumSlots(SLH_bagID)
					for SLH_slot = 1, SLH_Bag_numberOfSlots do
						local SLH_icon, 
							SLH_itemCount,
							SLH_locked, 
							SLH_quality, 
							SLH_readable, 
							SLH_lootable, --Lockbox ID?
							SLH_itemLink, 
							SLH_isFiltered, 
							SLH_noValue, 
							SLH_itemID = GetContainerItemInfo(SLH_bagID, SLH_slot)
							
						if SLH_itemLink ~= nil
						then 
							local SLH_NL_lootstring = string.match(SLH_itemLink, "item[%-?%d:]+")
							SLH_NL_Module(self, event, SLH_itemLink, SLH_NL_lootstring)
						end
					end
				end
				return
			end
			
			
		--SLH_NL EventCall
			local SLH_NL_Events = function (SLH_NLOptions, event, name, ...)
				--[[DevMode]]if SLH_NL_DevMode and event ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NL: " .. event) end
				--if _G_SLH["SLH_SV"][NL_Profile]["NL"]["DisableAtMaxLevel"] == "Y" and UnitLevel("player") == 60 then return end
				_G_SLH["SLH_SV"][NL_Profile]["NL"]["PausedWhileMailing"] = "N"
				
			
				Run_SLH_NL = CreateFrame("Frame","Run_SLH_NL")
				Run_SLH_NL:RegisterEvent("CHAT_MSG_LOOT")	
				Run_SLH_NL:RegisterEvent("MAIL_SHOW")		
				Run_SLH_NL:RegisterEvent("MAIL_CLOSED")			
				if _G_SLH["SLH_SV"][NL_Profile]["NL"]["Enable"] == "Y"
					then Run_SLH_NL:HookScript("OnEvent", SLH_NL_Delay)
				end
				
				Run_SLH_NL_PostCombat= CreateFrame("Frame","Run_SLH_NL_PostCombat")
				Run_SLH_NL_PostCombat:RegisterEvent("PLAYER_REGEN_ENABLED")		
				if _G_SLH["SLH_SV"][NL_Profile]["NL"]["Enable"] == "Y"
				then 
					Run_SLH_NL_PostCombat:HookScript("OnEvent", function (self, event, ...)		
						_G_SLH["SLH_SF"]["SLH_NL_PostCombat"](self, event, ...)	
					end)
				end
									
				if _G_SLH["SLH_SV"][NL_Profile]["NL"]["LogOnScan"] == "Y"
				then
					Run_SLH_NL_Scan = CreateFrame("Frame","Run_SLH_NL_Scan")
					Run_SLH_NL_Scan:RegisterEvent("PLAYER_ENTERING_WORLD")		
					if _G_SLH["SLH_SV"][NL_Profile]["NL"]["Enable"] == "Y"
					then 
						Run_SLH_NL_Scan:HookScript("OnEvent", function (self, event, ...)		
							_G_SLH["SLH_SF"]["SLH_NL_Scan"](self, event, ...)	
						end)
					end
				end
			end

		--SLH_NL Config Screen
			local SLH_NL_Frames = function  (self, event, name, ...)

				-- SLH_NL Options
					local SLH_NLOptions = CreateFrame( "Frame", "SLH_NLOptions")
					SLH_NLOptions.name = "New Lootables"
					-- Specify childness of this panel (this puts it under the little red [+], instead of giving it a normal AddOn category)
						SLH_NLOptions.parent = SLH_Config_Panel.name
					-- Add the child to the Interface Options
						InterfaceOptions_AddCategory(SLH_NLOptions)
					--Add Title
						local SLH_NLOptionsTitle = SLH_NLOptions:CreateFontString(nil, "ARTWORK","GameFontNormalLarge")
						SLH_NLOptionsTitle:SetPoint("TOPLEFT", 10, -10)
						SLH_NLOptionsTitle:SetText("Salen's Little Helper - New Lootables Options")

			
				--SLH_NLDetail - Create Scroll Frame		
					SLH_NLDetail = securecall(_G_SLH["SLH_SF"]["SLH_CreateScrollFrame"],SLH_NLOptions, --self
						"SLH_NLDetail", --FrameName
						SLH_NLOptions, --TOPLEFTrelativeFrame
						5, --TOPLEFTxOffset
						-30, --TOPLEFTyOffset
						SLH_NLOptions, --BOTTOMRIGHTrelativeFrame
						-5, --BOTTOMRIGHTxOffset
						5,--BOTTOMRIGHTyOffset
						"New Lootables Options" -- Title
						)
					SLH_NLDetail.ScrollBar:ClearAllPoints()
					SLH_NLDetail.ScrollBar:SetPoint("TOPLEFT", SLH_NLDetail, "TOPRIGHT", -25, -20)
					SLH_NLDetail.ScrollBar:SetPoint("BOTTOMRIGHT", SLH_NLDetail, "BOTTOMRIGHT", -5, 25)
					SLH_NLDetail:SetClipsChildren(true)		
					
					--(Uncomment to) Set Background Color
						--SLH_NLDetail.bg = SLH_NLDetail:CreateTexture(nil, "BACKGROUND")
						--SLH_NLDetail.bg:SetAllPoints(true)
						--SLH_NLDetail.bg:SetColorTexture(0.8, 0.4, 0, 0.2)
					--End Set Background Color

					--SLH_NLDetailScrollFrameChild
						local SLH_NLDetailScrollFrameChild = CreateFrame("Frame", nil, SLH_NLDetail)
						SLH_NLDetailScrollFrameChild:SetSize(600, 470)
							--(Uncomment to) Set Background Color
								--SLH_NLDetailScrollFrameChild.bg = SLH_NLDetailScrollFrameChild:CreateTexture(nil, "BACKGROUND")
								--SLH_NLDetailScrollFrameChild.bg:SetAllPoints(true)
								--SLH_NLDetailScrollFrameChild.bg:SetColorTexture(0.2, 0.6, 0, 0.8)
							--End Set Background Color
						SLH_NLDetail:SetScrollChild(SLH_NLDetailScrollFrameChild)	
						SLH_NLDetailScrollFrameChild:SetClipsChildren(true)		
			
					

					--SLH_NLDetail Title 
						SLH_NLDetailScrollFrameChild.title = SLH_NLDetailScrollFrameChild:CreateFontString (nil, "OVERLAY")
						SLH_NLDetailScrollFrameChild.title:SetFontObject("GameFontHighlight")
						SLH_NLDetailScrollFrameChild.title:SetPoint("LEFT", SLH_NLDetailScrollFrameChild.TitleBg, "LEFT", 5, 0)
						SLH_NLDetailScrollFrameChild.title:SetText("New Lootables Options")	
						SLH_NLDetailScrollFrameChild.title:SetTextColor(_G_SLH["SLH_SF"]["SLH_TitleColors"].r, _G_SLH["SLH_SF"]["SLH_TitleColors"].g, _G_SLH["SLH_SF"]["SLH_TitleColors"].b, _G_SLH["SLH_SF"]["SLH_TitleColors"].a)					

					--MasterFrame.SLH_NLDetail Buttons
						-- Enable_SLH_NL Check Button:
							Enable_SLH_NL = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_NLOptions, --self
								"TOPLEFT", --point
								SLH_NLDetailScrollFrameChild, --relativeFrame
								"Enable_SLH_NL", --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								10, --xOffset
								-20, --yOffset
								"SLH_SV", --SVPath0
								NL_Profile, --SVPath1
								"NL", --SVPath2
								"Enable", --SVPath3
								"Enable New Lootables", --text
								"Creates a PopUp Icon for using the new Lootable\n\nLeft Click to Use it, Right Click to Close the icon.\n\nIcon will Automatically Hide During Combat." --tooltip
								)
								Enable_SLH_NL:HookScript("OnClick", function(self, arg1)			
									if Enable_SLH_NL:GetChecked() 
										then 
											_G_SLH["SLH_SV"][NL_Profile]["NL"]["Enable"] = "Y"
											SLH_NL_SetVars(self, event, name)
											SLH_NL_Events(self, event, name)
										else 
											_G_SLH["SLH_SV"][NL_Profile]["NL"]["Enable"] = "N"
											--if _G_SLH["SLH_SV"][NL_Profile]["NL"]["DisableAtMaxLevel"] == "Y" and UnitLevel("player") == 60 then return end
											
											if Run_SLH_ActiveQuests then Run_SLH_ActiveQuests:UnregisterAllEvents()	end
											if Run_SLH_CompleteQuests then Run_SLH_CompleteQuests:UnregisterAllEvents()	end
											if Run_SLH_AvailableQuests then Run_SLH_AvailableQuests:UnregisterAllEvents()	end
											if Run_SLH_AcceptQuests then Run_SLH_AcceptQuests:UnregisterAllEvents()	end				
									end
								end)
										
						-- SLH_NL_SLH_xOfs - in seconds
							SLH_NL_SLH_xOfs = securecall(_G_SLH["SLH_SF"]["SLH_CreateSlider"],SLH_NLOptions, --
								"TOPLEFT", --point
								Enable_SLH_NL, --relativeFrame
								"SLH_NL_SLH_xOfs" , --FrameName
								"BOTTOMLEFT", --relativePoint
								10, --xOffset
								-40, --yOffset
								-1000, --Min
								1000, --Max
								_G_SLH["SLH_SV"][NL_Profile]["NL"]["xOfs"], --Value
								20, --Step
								"SLH_SV", --SVPath0
								NL_Profile, --SVPath1
								"NL", --SVPath2
								"xOfs", --SVPath3
								"Set X Coordinate?", --text
								"Set X Coordinate\n\nThis is in case the button is moved off screen and you need to recover it.\n\nCoordinates are from center of the screen. Center = 0 , Default = 40\n\nThis setting requires a reload after a change." --tooltip
								)
										
						-- SLH_NL_SLH_yOfs - in seconds
							SLH_NL_SLH_yOfs = securecall(_G_SLH["SLH_SF"]["SLH_CreateSlider"],SLH_NLOptions, --
								"TOPLEFT", --point
								SLH_NL_SLH_xOfs, --relativeFrame
								"SLH_NL_SLH_yOfs" , --FrameName
								"BOTTOMLEFT", --relativePoint
								0, --xOffset
								-50, --yOffset
								-1000, --Min
								1000, --Max
								_G_SLH["SLH_SV"][NL_Profile]["NL"]["yOfs"], --Value
								20, --Step
								"SLH_SV", --SVPath0
								NL_Profile, --SVPath1
								"NL", --SVPath2
								"yOfs", --SVPath3
								"Set Y Coordinate?", --text
								"Set Y Coordinate\n\nThis is in case the button is moved off screen and you need to recover it.\n\nCoordinates are from center of the screen. Center = 0 , Default = 320\n\nThis setting requires a reload after a change." --tooltip
								)
								
						-- SLH_NL_DisableForCrafting - in seconds								
							SLH_NL_DisableForCrafting = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_NLOptions, --self
								"TOPLEFT", --point
								SLH_NL_SLH_yOfs, --relativeFrame
								"SLH_NL_DisableForCrafting", --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								0, --xOffset
								-40, --yOffset
								"SLH_SV", --SVPath0
								NL_Profile, --SVPath1
								"NL", --SVPath2
								"DisableForCrafting", --SVPath3
								"Disable when you Craft the item?", --text
								"Disables when you Craft the item\n\nThis setting requires a reload after a change." --tooltip
								)
								
						-- SLH_NL_SLH_yOfs - in seconds								
							SLH_NL_DisableWhenMailBoxIsOpen = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_NLOptions, --self
								"TOPLEFT", --point
								SLH_NL_DisableForCrafting, --relativeFrame
								"SLH_NL_DisableWhenMailBoxIsOpen", --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								0, --xOffset
								-20, --yOffset
								"SLH_SV", --SVPath0
								NL_Profile, --SVPath1
								"NL", --SVPath2
								"DisableWhenMailBoxIsOpen", --SVPath3
								"Disable when Mailbox is open?", --text
								"Disables when Mailbox is open" --tooltip
								)
								

						
								
						--Right Side
								
						-- SLH_NL_LogOnScan Check Button:
							SLH_NL_LogOnScan = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_NLOptions, --self
								"TOPLEFT", --point
								Enable_SLH_NL, --relativeFrame
								"SLH_NL_LogOnScan", --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								280, --xOffset
								0, --yOffset
								"SLH_SV", --SVPath0
								NL_Profile, --SVPath1
								"NL", --SVPath2
								"LogOnScan", --SVPath3
								"Run Scan on Loading UI?", --text
								"Runs Scan when Loading UI.\n\nIn case you missed opening something." --tooltip
								)
								
										
			end

				
			if _G_SLH["SLH_PCSV"][SLH_PCSV_UnitName]["Config"]["NL_Load"] == "Y" then
				SLH_NL_SetVars(self, event, name, ...)
				SLH_NL_Events(self, event, name, ...)
			end
			if _G_SLH["SLH_PCSV"][SLH_PCSV_UnitName]["Config"]["NL_Hide"] == "N" then
				SLH_NL_Frames(self, event, name, ...)
			end
		
	end	)	

