--Run SLH_Config_Lua  	
	SLH_QA_Lua = CreateFrame("Frame", "SLH_QA_Lua")
	SLH_QA_Lua:RegisterEvent("ADDON_LOADED")
	SLH_QA_Lua:HookScript("OnEvent", function (self, event, name, ...)
		if (name ~= "SalensLittleHelper") then return end

		--Theoretically speeds up access to global variables by making them local.  This is supposed to be faster.  I have no proof this is true.	
			local _G_SLH = _G 

		local SLH_PCSV_UnitName = _G_SLH["SLH_PCSV"]["SLH_PCSV_UnitNameGlobal"]
		local QA_Profile = _G_SLH["SLH_PCSV"][SLH_PCSV_UnitName]["Config"]["QA_Profile"]
		
		--Development Mode Boolean (Controls various Overrides, disable to test and distribute.)
			local SLH_QA_DevMode = false
			local SLH_QA_GetZoneAndText_DevMode = false
			--[[DevMode]]if SLH_QA_DevMode and name ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("QA_Lua addonName: " .. name) end	

		-- Set Variables
			local SLH_QA_SetVars = function (self, event, name, ...)
				-- Test/Create SLH_SV Table			
					if _G_SLH["SLH_SV"] == nil then _G_SLH["SLH_SV"] = {} end			
				-- Test/Create SLH_SV.QA_Profile Table
					if _G_SLH["SLH_SV"][QA_Profile] == nil then _G_SLH["SLH_SV"][QA_Profile] = {}  end	
				-- Test/Create SLH_QA Table
					if _G_SLH["SLH_SV"][QA_Profile]["QA"] == nil then _G_SLH["SLH_SV"][QA_Profile]["QA"] = {}  end	
						
				-- Test/Create SLH_QA Variables
					if _G_SLH["SLH_SV"][QA_Profile]["QA"]["Enable"] == nil then _G_SLH["SLH_SV"][QA_Profile]["QA"]["Enable"] = "Y" end
					if _G_SLH["SLH_SV"][QA_Profile]["QA"]["QuestListDelay"] == nil then _G_SLH["SLH_SV"][QA_Profile]["QA"]["QuestListDelay"] = 0 end
					if _G_SLH["SLH_SV"][QA_Profile]["QA"]["QuestAcceptDelay"] == nil then _G_SLH["SLH_SV"][QA_Profile]["QA"]["QuestAcceptDelay"] = 0 end
					if _G_SLH["SLH_SV"][QA_Profile]["QA"]["QuestCompleteDelay"] == nil then _G_SLH["SLH_SV"][QA_Profile]["QA"]["QuestCompleteDelay"] = 0 end
					if _G_SLH["SLH_SV"][QA_Profile]["QA"]["QuestRewardSelectDelay"] == nil then _G_SLH["SLH_SV"][QA_Profile]["QA"]["QuestRewardSelectDelay"] = 0 end
					if _G_SLH["SLH_SV"][QA_Profile]["QA"]["AutoSelectRewards"] == nil then _G_SLH["SLH_SV"][QA_Profile]["QA"]["AutoSelectRewards"] = "Y" end
					if _G_SLH["SLH_SV"][QA_Profile]["QA"]["QuestRewardSelectionCriteria"] == nil then _G_SLH["SLH_SV"][QA_Profile]["QA"]["QuestRewardSelectionCriteria"] = "Largest Item Level Upgrade" end
					if _G_SLH["SLH_SV"][QA_Profile]["QA"]["ExcludeWeapons"] == nil then _G_SLH["SLH_SV"][QA_Profile]["QA"]["ExcludeWeapons"] = "Y" end
					if _G_SLH["SLH_SV"][QA_Profile]["QA"]["ShowAutoSelectDisabledMessage"] == nil then _G_SLH["SLH_SV"][QA_Profile]["QA"]["ShowAutoSelectDisabledMessage"] = "Y" end
					if _G_SLH["SLH_SV"][QA_Profile]["QA"]["DisableAtMaxLevel"] == nil then _G_SLH["SLH_SV"][QA_Profile]["QA"]["DisableAtMaxLevel"] = "N" end
					if _G_SLH["SLH_SV"][QA_Profile]["QA"]["QuestSharing"] == nil then _G_SLH["SLH_SV"][QA_Profile]["QA"]["QuestSharing"] = "Y" end
					if _G_SLH["SLH_SV"][QA_Profile]["QA"]["GossipText"] == nil then _G_SLH["SLH_SV"][QA_Profile]["QA"]["GossipText"] = "Y" end
			end

		--SLH_QA Module

			--SLH_QA_GossipText
				local SLH_QA_GossipText = function (SLH_QAOptions, event, name, questStartItemID, ...)						
					if IsAltKeyDown() then return end										
					if _G_SLH["SLH_SV"][QA_Profile]["QA"]["GossipText"] ~= "Y" then return end	
					--[[DevMode]]if SLH_QA_DevMode and event ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("QA_GossipText: " .. event) end		
					
					--End to prevent interference with Accepting Available Quests
					local SLH_QA_GossipText_GossipInfoGetNumAvailableQuests = C_GossipInfo.GetNumAvailableQuests()		
					--[[DevMode]]if SLH_QA_DevMode and SLH_QA_GossipText_GossipInfoGetNumAvailableQuests ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("QA_AvailableQuests SLH_QA_GossipText_GossipInfoGetNumAvailableQuests: " .. SLH_QA_GossipText_GossipInfoGetNumAvailableQuests) end
					if not(SLH_QA_GossipText_GossipInfoGetNumAvailableQuests == nil) and SLH_QA_GossipText_GossipInfoGetNumAvailableQuests > 0  then return end
					local SLH_QA_GossipText_GetNumAvailableQuests = GetNumAvailableQuests()			
					--[[DevMode]]if SLH_QA_DevMode and SLH_QA_GossipText_GetNumAvailableQuests ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("QA_GossipText_GetNumAvailableQuests: " .. SLH_QA_GossipText_GetNumAvailableQuests) end
					if not(SLH_QA_GossipText_GetNumAvailableQuests == nil) and SLH_QA_GossipText_GetNumAvailableQuests > 0  then return end
		
					--End to prevent interference with Turning in Completed Quests
					local SLH_QA_GossipText_GossipInfoGetNumActiveQuests = C_GossipInfo.GetNumActiveQuests()	
					--[[DevMode]]if SLH_QA_DevMode and SLH_QA_GossipText_GossipInfoGetNumActiveQuests ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("QA_GossipText_GossipInfoGetNumActiveQuests: " .. SLH_QA_GossipText_GossipInfoGetNumActiveQuests) end									
					if not(SLH_QA_GossipText_GossipInfoGetNumActiveQuests == nil) and SLH_QA_GossipText_GossipInfoGetNumActiveQuests > 0
					then
						for i=1, SLH_QA_GossipText_GossipInfoGetNumActiveQuests do	
							local SLH_QA_GossipText_questID = C_GossipInfo.GetActiveQuests()[i].questID								
							--[[DevMode]]if SLH_QA_DevMode and SLH_QA_GossipText_questID ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("QA_GossipText_questID: " .. SLH_QA_GossipText_questID) end									
							local SLH_QA_GossipText_isComplete = C_QuestLog.IsComplete(SLH_QA_GossipText_questID)
							--[[DevMode]]if SLH_QA_DevMode then if SLH_QA_GossipText_isComplete and SLH_QA_GossipText_questID ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"](SLH_QA_GossipText_questID .. " Complete") else _G_SLH["SLH_SF"]["Config"]["Print"](SLH_QA_GossipText_questID .. " Not Complete") end end
							if SLH_GossipActiveQuests_isComplete
							then 
								return		
							end
						end	
					end						
					local SLH_QA_GossipText_GetNumActiveQuests = GetNumActiveQuests()	
					--[[DevMode]]if SLH_QA_DevMode and SLH_QA_GossipText_GetNumActiveQuests ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("QA_GossipText_GetNumActiveQuests: " .. SLH_QA_GossipText_GetNumActiveQuests) end
					if not(SLH_QA_GossipText_GetNumActiveQuests == nil) and SLH_QA_GossipText_GetNumActiveQuests > 0
					then
						for i=1, SLH_QA_GossipText_GetNumActiveQuests do	
							local SLH_QA_GossipText_questID = GetActiveQuestID(i)							
							--[[DevMode]]if SLH_QA_DevMode and SLH_QA_GossipText_questID ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("QA_GossipText_questID: " .. SLH_QA_GossipText_questID) end	
							local SLH_QA_GossipText_isComplete = C_QuestLog.IsComplete(SLH_QA_GossipText_questID)
							--[[DevMode]]if SLH_QA_DevMode and SLH_QA_GossipText_questID ~= nil then if SLH_QA_GossipText_isComplete then _G_SLH["SLH_SF"]["Config"]["Print"](SLH_QA_GossipText_questID .. " Complete") else _G_SLH["SLH_SF"]["Config"]["Print"](SLH_QA_GossipText_questID .. " Not Complete") end end
							if SLH_GossipActiveQuests_isComplete
							then 
								return		
							end
						end	
					end	
		
					--Start Gossip Text Processing
					local SLH_numOptions = C_GossipInfo.GetNumOptions()			
					--[[DevMode]]if SLH_QA_DevMode and SLH_numOptions ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("QA_GossipText numOptions: " .. SLH_numOptions) end
					local SLH_GossipInfoGetOptionsTable = C_GossipInfo.GetOptions()

					--Quick Global Search
					for i=1, SLH_numOptions do	
						--[[DevMode]]--if SLH_QA_DevMode and SLH_GossipInfoGetOptionsTable[i].name ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("QA_GossipText QuickName: " .. tostring(SLH_GossipInfoGetOptionsTable[i].name)) end
						if string.find(SLH_GossipInfoGetOptionsTable[i].name, "(Quest)") ~= nil
						then
							C_GossipInfo.SelectOption(i);
							return
						end				
					end			
																
					local SLH_QA_TextList = {
						"I'd like to check my mail.", --Katy Stampwhistle
					}
					--[[DevMode]]if SLH_QA_GetZoneAndText_DevMode and SLH_numOptions ~= nil and GetZoneText() ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("QA_GossipText Zone: " .. GetZoneText()) end
					if GetZoneText() == "Ardenweald" 
					then 	
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I have the lily."--I Moustache You to Lend a Hand
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Will you help me gain an audience with the Queen?"--I Moustache You to Lend a Hand
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I'm standing in for Lady Moonberry. What happened?"--Wildseed Rescue
						SLH_QA_TextList[#SLH_QA_TextList+1] = "What's a wildseed?"--Wildseed Rescue
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I'll help you."--Wildseed Rescue
						SLH_QA_TextList[#SLH_QA_TextList+1] = "<Hold still?>"--Wildseed Rescue
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I will help you."--Souls of the Forest
						SLH_QA_TextList[#SLH_QA_TextList+1] = "You're welcome."--Souls of the Forest
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I'm going that way, too. I'll help."--Keep to the Path
						SLH_QA_TextList[#SLH_QA_TextList+1] = "My, what big teeth you have Granny."--Keep to the Path
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Hey! What's the big idea?"--Keep to the Path
						SLH_QA_TextList[#SLH_QA_TextList+1] = "<Express your appreciation for her help.>"--Keep to the Path
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Let's get you out of here."--Nothing Left to Give
						SLH_QA_TextList[#SLH_QA_TextList+1] = "It's fine, you can leave with me now."--Nothing Left to Give
						SLH_QA_TextList[#SLH_QA_TextList+1] = "The fuss is, it's time to leave."--Nothing Left to Give
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I'll take the animacones and infuse this wildseed with their anima."--One Special Spirit
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I'm ready to be properly prepared to meet the Winter Queen."--Preparing for the Winter Queen
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I need you to use some of your anima to destroy the droman's barrier."--Recovering the Heart
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I'm ready to meet the Winter Queen."--Audience with the Winter Queen
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Hunt-Captain Korayn says to report back to the grove."--The Missing Hunters
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Who was that? What now?"--I Know Your Face
						SLH_QA_TextList[#SLH_QA_TextList+1] = "The Lady of the Falls wanted to make sure you were safe."--Return to Tirna Vaal
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I'm taking the wildseed responsible for this to Hibernal Hollow. I could use your help bringing it there."--The Way to Hibernal Hollow
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I'm ready to take this wildseed to Hibernal Hollow."--Soothing Song
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I'm ready to travel to the Hibernal Hollow."--Passage to Hibernal Hollow
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Droman Aliothe said you were storing anima that we could use to help a wildseed."--Infusing the wildseed						
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Thank you Proglo. I'll use this anima to help the wildseed."--Infusing the wildseed		
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I'm ready to perform the ritual on the wildseed."--Infusing the Wildseed	
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I'm ready to perform the ritual on the wildseed."--Infusing the Wildseed	
						SLH_QA_TextList[#SLH_QA_TextList+1] = "<Listen to the tale of Tirna Noch.>"--Echoes of Tirna Noch
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I'm ready to borrow some wings and rain sparkly terror."--Sparkles Rain from Above
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am ready to stand with you!"--Battle for Hibernal Hollow
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am ready to go."--Dying Dreams						
						--SLH_QA_TextList[#SLH_QA_TextList+1] = "(Quest)I am ready to relive the Dreamer's nightmare."--End of the Dream
						SLH_QA_TextList[#SLH_QA_TextList+1] = "<Deliver the Primus's Message.>"--The Court of Winter
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Yes, your majesty?"--The Court of Winter
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Is everything under control here?"--Can't Turn our Backs
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Is the sigil safe?"--The Heart of Ardenweald
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Here are the joyful memories I collected from Heartwood Grove."--The Heart of Ardenweald
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I'm ready for the disguise."--The Heart of Ardenweald
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Ardenweald has asked for help finding former Night Warriors."--Hunting Amid Houses
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I see. Thank you."--Hunting Amid Houses
						SLH_QA_TextList[#SLH_QA_TextList+1] = "You were a Night Warrior in life?"--Rituals of Night
						SLH_QA_TextList[#SLH_QA_TextList+1] = "We're ready to begin the ritual."--The power of Elune
						SLH_QA_TextList[#SLH_QA_TextList+1] = "<Hand the Sister's Tear to Ysera.>"--Winter's Sigil
					
					elseif GetZoneText() == "Bastion" 
					then 	
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Lead on, Kleia." --Welcome to Eternity
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I think there might have been a mistake." --A Fate most Noble
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am not dead." --A Fate most Noble
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I come from Azeroth." --A Fate most Noble
						SLH_QA_TextList[#SLH_QA_TextList+1] = "<Tell Kleia what you saw in the Maw.>" --A Fate most Noble
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Do you have \"Worlds Beyond Counting\"?" --Suggested Reading
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Do you have \"The Infinite Treatises\"?" --Suggested Reading
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Show me what to do, Sika." --The Work of One's Hands
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Will you spar with me?" --Assessing your Stamina
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I would like to challenge both of you to a spar." --Assessing your Stamina
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am ready to begin." --The First Cleansing
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I wish to speak to the Archon." --The Archon's Answer
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I will help you." --A Temple in Need
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Tell me how I can help." --A Temple in Need
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Begin the cleansing. I am ready." --A Temple in Need
						SLH_QA_TextList[#SLH_QA_TextList+1] = "You can do this. I believe in you." --On the Edge of a Revelation
						SLH_QA_TextList[#SLH_QA_TextList+1] = "We will get through this together!" --On the Edge of a Revelation
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Trust in your teachings. They have not led you astray before." --On the Edge of a Revelation
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Eridia asked me to find you." --A Wayward Disciple
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Yes, Eridia." --Step Back From That Ledge, My Friend
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Are you well?" --Step Back From That Ledge, My Friend
						SLH_QA_TextList[#SLH_QA_TextList+1] = "What is it? What is wrong?" --Step Back From That Ledge, My Friend
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am ready." --The Enemy You Know
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I will stand with you." --The Hand of Doubt
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I will fly with you." --Purity's Prerogative
						SLH_QA_TextList[#SLH_QA_TextList+1] = "What do we do now?" --The Vault of the Archon
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I need assistance." --Your Personal Assistant
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I need to go to the Temple of Courage." --Imminent Danger
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am with you." --Now or Never
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am ready to go to Elysian Hold." --On Swift Wings
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am ready to speak to the Archon." --Kyrestia, the Firstborne
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Take me to Elysian Hold." --Blind Loyalty
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am ready to attend the ceremony." --The New Path
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am ready for the ceremony." --The New Path
					
					elseif GetZoneText() == "Blasted Lands" 
					then 			
						--Start Shadowlands
						SLH_QA_TextList[#SLH_QA_TextList+1] = "FOR AZEROTH!" --WoD: The Dark Portal						
										
					elseif GetZoneText() == "Frostfire Ridge" 
					then  					
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am ready, Khadgar. Let's use the All-Seeing Ring." --All is Revealed
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Spirit of the Wolf" --Stone
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Pul, I need to quickly return to Bladespire Citadel." --Back to Bladespire Citadel
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am ready!" --Let the Hunt Begin
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Break the chains." --Into the Boneslag
													
					elseif GetZoneText() == "Frostwall" 
					then  					
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Get the peons back to work." --What we got
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Gazlowe needs you." --What we got
													
					elseif GetZoneText() == "Gorgrond" 
					then  	
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Thank you for not killing me.  What duty have you failed?" --Ambassador to the Ancient
						SLH_QA_TextList[#SLH_QA_TextList+1] = "What were you supposed to do?" --Ambassador to the Ancient
						SLH_QA_TextList[#SLH_QA_TextList+1] = "So getting that bloom back might fix things... interesting..." --Ambassador to the Ancient
												
					elseif GetZoneText() == "Grulloc's Grotto" 
					then  	
						SLH_QA_TextList[#SLH_QA_TextList+1] = "<Assist Ga'nar in battle.>" --The Eldest
				
					elseif GetZoneText() == "Korthia" 
					then  					
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Scan the area to see what exactly might be nearby." --Korthia, the City of Secrets
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Lead the way, Tal-Galan." --Korthia, the City of Secrets
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I'm prepared for your Maw Walker test." --Korthia, the City of Secrets
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Bolvar requests your current report." --Surveying Secrets
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I will guard you while you finish the report." --Surveying Secrets
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am ready." --Ease of Passage
						SLH_QA_TextList[#SLH_QA_TextList+1] = "<Tell Bolvar of all that has transpired.>" --Good News, Everyone
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I found more relics we can use for our cataloged research." --Research turnin
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I'm ready to see the message regarding what is within the vault." --Secrets of the vault
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Begin the repairs. I will defend you." --Hooking over
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am ready. Let's open the way." --Into the vault
						SLH_QA_TextList[#SLH_QA_TextList+1] = "What should we do with the sigil?" --Untangling the sigil
						SLH_QA_TextList[#SLH_QA_TextList+1] = "<Give Draka a moment with Thrall.>" --Victory in Our Name
						SLH_QA_TextList[#SLH_QA_TextList+1] = "<Witness the end of the battle.>" --Doorway in the Dark
						SLH_QA_TextList[#SLH_QA_TextList+1] = "<Signal the Primus to begin.>" --Covenants Renewed.
						SLH_QA_TextList[#SLH_QA_TextList+1] = "<Present the sigils to the Primus.>" --Covenants Renewed.
						
					elseif GetZoneText() == "Maldraxxus" 
					then  
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Tell me your story." --The house of the Chosen
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Reporting for duty. I'm to prepare for war against the other houses." --The First Act of War
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I have orders from Baron Vyraz." --Maintaining Order
						SLH_QA_TextList[#SLH_QA_TextList+1] = "You're acting suspicious." --The Hills Have Eyes.
						SLH_QA_TextList[#SLH_QA_TextList+1] = "What do you know about this blade?" --Forging a Champion
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am ready to start forging a rune weapon." --The Blade of the Primus
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I'm ready. Let's fly to the Seat of the Primus." --The Seat of the Primus
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I have a summons from Draka." --A Common Peril
						--SLH_QA_TextList[#SLH_QA_TextList+1] = "What's your story?" --Glorious Pursuits -- Causes other quests to this NPC to not turn in.
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I'm ready. Begin the ritual." --War is Deception
						SLH_QA_TextList[#SLH_QA_TextList+1] = "How would you breach the barrier?" --Breaking Down Barriers
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I need you to follow my directions." --Breaking Down Barriers
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Ardenweald has asked for help finding former Night Warriors." --The Blade in the Night
						SLH_QA_TextList[#SLH_QA_TextList+1] = "<Explain the situation and request Khaliiq's help for Ardenweald.>" --The Blade in the Night
					
					elseif GetZoneText() == "Orgrimmar" 
					then 			
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Tell me what happened." --Shadowlands: A Chilling Summons					
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I must help Khadgar. Send me to the Blasted Lands!" --WoD: The Dark Portal				
					
					elseif GetZoneText() == "Oribos" 
					then 				
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I want to speak with you about the, \"Threads of Fate\"" --Fate's Reminder
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am ready to choose my fate in the Shadowlands." --The Threads of Fate
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Where am I? Have I escaped the Maw?" --Stranger in an Even Stranger Land								
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Are you in charge here? Where am I?" --Stranger in an Even Stranger Land					
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Yes, I escaped the Maw." --No Place for the Living
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I will join you." --Audience with the Arbiter
						SLH_QA_TextList[#SLH_QA_TextList+1] = "What is this place?" --Audience with the Arbiter
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am ready to return." --Audience with the Arbiter
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Let's head outside." --A Doorway Through the Veil		
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Summon the portals here." --A Doorway Through the Veil		
						SLH_QA_TextList[#SLH_QA_TextList+1] = "What is available here?" --The Eternal City		
						SLH_QA_TextList[#SLH_QA_TextList+1] = "What is this Hall of Holding?" --The Eternal City		
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Thank you for the kind welcome to your Inn." --The Eternal City		
						SLH_QA_TextList[#SLH_QA_TextList+1] = "What is this place?" --The Eternal City		
						SLH_QA_TextList[#SLH_QA_TextList+1] = "What is this bazaar?" --The Eternal City		
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Can you help us find answers?" --The Eternal City		
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I will go with you." --Understanding the Shadowlands		
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am ready. Send me to Bastion." --Seek the Ascended				
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Maldraxxus has attacked Bastion." --Follow the Path	
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am ready. Send me to Maldraxxus." --If you want Peace...	
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am ready. Send me to Ardenweald." --Journey to Ardenweald							
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am ready. Send me to Revendreth." --Journey to Revendreth							
						SLH_QA_TextList[#SLH_QA_TextList+1] = "<Ask Adrestes what happened in Elysian Hold.>" --The First Move							
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am ready." --A Gathering of Covenants						
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I'm ready to begin." --Voices of the Eternal - must precede )"<Leave the Arbiter's Chamber.>" --Voices of the Eternal)
						SLH_QA_TextList[#SLH_QA_TextList+1] = "<Leave the Arbiter's Chamber.>" --Voices of the Eternal
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I'm prepared for you to examine my anima." --Opening The Maw
					
					elseif GetZoneText() == "Revendreth" 
					then  					
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Come with me." --Bottom Feeders
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Ready." --To Darkhaven
						SLH_QA_TextList[#SLH_QA_TextList+1] = "<Request tithe>" --Bring Out the Tithe						
						SLH_QA_TextList[#SLH_QA_TextList+1] = "<Deliver Prince Renathal's invitation.>"--Harvester of Desire
						SLH_QA_TextList[#SLH_QA_TextList+1] = "<Present the Offer of Employment.>"--Reestablishing the Household
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Are you enjoying yourself?"--Mix, Mingle, and Meddle
						SLH_QA_TextList[#SLH_QA_TextList+1] = "You stand accused of conspiring to overthrow The Countess."--Enacting Immediate Justice
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Prince Renathal is assembling a diplomatic envoy to the Stonewright." --Dread Tidings
						SLH_QA_TextList[#SLH_QA_TextList+1] = "What happened?" --Convoy to the Covenants
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Prince Renathal plans to petition the Stonewright." --Convoy to the Covenants
						SLH_QA_TextList[#SLH_QA_TextList+1] = "What's the plan?" --Hunting Huln
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am ready for my disguise." --Hunting Huln
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Have you seen anything unusual?" --Hunting Huln
						SLH_QA_TextList[#SLH_QA_TextList+1] = "That dreadlord tried to bribe me into freeing him. These Sigils of Binding weren't very secure." --Mal'appropriated
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Have you seen anyone unusual being taken into custody?" --Mal'appropriated
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Okay. What should we do?" --The Big Squeeze
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Okay." --The Big Squeeze
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Have you seen a large, blue soul with horns that doesn't look like he belongs in Revendreth?" --The Big Squeeze
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Has the Stonewright passed this way with a captive recently?" --Out on the edge
						SLH_QA_TextList[#SLH_QA_TextList+1] = "<Quickly explain what is going on.>" --Out on the edge
						
					elseif GetZoneText() == "Seat of the Archon" 
					then 							
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am ready for the ceremony." --The New Path
										
					elseif GetZoneText() == "Skyhold" 
					then  					
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am ready to begin." --The Chosen Few
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am ready to bear witness, Odyn." --Wrath of Odyn
						
					elseif GetZoneText() == "Tanaan Jungle" 
					then 			
						--Start Shadowlands
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Khadgar has asked us to go distract the Eye of Kilrogg." --Altar Altercation	
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Yes. I need you to help me operate that enormous tank." --Taking a trip to the top of the tank
					
					elseif GetZoneText() == "The Maw" 
					then  					
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am ready." --A Flight from Darkness
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Tell me about this place." --A Moment's Respite
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Tell me more of the Jailer." --A Moment's Respite
						SLH_QA_TextList[#SLH_QA_TextList+1] = "What about the others who were taken?" --A Moment's Respite
						SLH_QA_TextList[#SLH_QA_TextList+1] = "<Lie low and observe.>" --A Moment's Respite
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Make it talk." --From the Mouths of Madness						
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Let's go." --Delving Deeper
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I need your help to find a second waystone to create a permanent connection to Oribos." --Link to the Maw
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I'm ready, let's move." --Mysteries of the Maw
						SLH_QA_TextList[#SLH_QA_TextList+1] = "The bag you had me carry wasn't yours?" --Grab Bag
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I'm ready! <Fly with Danica to Skyhold.>" --Grab Bag
						SLH_QA_TextList[#SLH_QA_TextList+1] = "How do I bind this horn to the Maw?" --Mawsplaining
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I'm ready!" --Good News, Everyone!
						SLH_QA_TextList[#SLH_QA_TextList+1] = "What are your ground rules for working together?" --Setting the Ground Rules
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Deal. I will tell no one about you in exchange for the Soulkeeper." --Setting the Ground Rules
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am ready to assist you." --Report to Xandria
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Let's fly, Xandria." --Report to Xandria
						SLH_QA_TextList[#SLH_QA_TextList+1] = "How can I help the assault, Prince Renathal?" --Assault
					
					elseif GetZoneText() == "Torghast, Tower of the Damned" 
					then  					
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Free the Soul Remnant." --Soul Remnant
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Yes, I will help." --Moriaz the Red
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I will assist you." --Sawn
						SLH_QA_TextList[#SLH_QA_TextList+1] = "Do not worry, I will free you." --Kaletar
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I need your help. We need to seal this sigil so the Jailer cannot retrieve it." --Untangling the Sigil
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I'll help however I can." --Defending the Primus
										
					elseif GetZoneText() == "Wor'gol" 
					then  					
						SLH_QA_TextList[#SLH_QA_TextList+1] = "I am ready for the ritual, farseer." --Pool of Visions
								
					elseif GetZoneText() == "CopyForNewZone" 
					then 			
						SLH_QA_TextList[#SLH_QA_TextList+1] = "" --
					end

					for i=1, SLH_numOptions do	
					--[[DevMode]]if SLH_QA_GetZoneAndText_DevMode and SLH_GossipInfoGetOptionsTable[i].name ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("QA_GossipText Text: " .. SLH_GossipInfoGetOptionsTable[i].name) end
						if tContains(SLH_QA_TextList, SLH_GossipInfoGetOptionsTable[i].name)
						then
							C_GossipInfo.SelectOption(i);
							return
						end
						
					end		
					return
				end
				
			-- Turn in Quests
				local SLH_QA_ActiveQuests = function (SLH_QAOptions, event, name, questStartItemID, ...)
					if IsAltKeyDown() then return end
					--[[DevMode]]if SLH_QA_DevMode and event ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("QA_ActiveQuests: " .. event) end	
							
					local SLH_NumGossipActiveQuests = C_GossipInfo.GetNumActiveQuests()	
					--[[DevMode]]if SLH_QA_DevMode and SLH_NumGossipActiveQuests ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("QA_ActiveQuests SLH_NumGossipActiveQuests: " .. SLH_NumGossipActiveQuests) end						
					
					local SLH_GetNumActiveQuests = GetNumActiveQuests()	
					--[[DevMode]]if SLH_QA_DevMode and SLH_GetNumActiveQuests ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("QA_ActiveQuests SLH_GetNumActiveQuests: " .. SLH_GetNumActiveQuests) end
					
					if not(SLH_NumGossipActiveQuests == nil) and SLH_NumGossipActiveQuests > 0
					then
						for i=1, SLH_NumGossipActiveQuests do	
							--Is Quest Complete?
							local SLH_GossipActiveQuests_questID = C_GossipInfo.GetActiveQuests()[i].questID							
							--[[DevMode]]if SLH_QA_DevMode and SLH_GossipActiveQuests_questID ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("QA_ActiveQuests ActiveQuests_questID: " .. SLH_GossipActiveQuests_questID) end	
							local SLH_GossipActiveQuests_isComplete = C_QuestLog.IsComplete(SLH_GossipActiveQuests_questID)
							--[[DevMode]]if SLH_QA_DevMode and SLH_GossipActiveQuests_questID ~= nil then if SLH_ActiveQuests_isComplete then _G_SLH["SLH_SF"]["Config"]["Print"](SLH_GossipActiveQuests_questID .. " Complete") else _G_SLH["SLH_SF"]["Config"]["Print"](SLH_GossipActiveQuests_questID .. " Not Complete") end end
							
							if SLH_GossipActiveQuests_isComplete
							then 
								C_GossipInfo.SelectActiveQuest(i)	
							end
						end
					elseif not(SLH_GetNumActiveQuests == nil) and SLH_GetNumActiveQuests > 0
					then
						for i=1, SLH_GetNumActiveQuests do		
							--Is Quest Complete?
							local SLH_ActiveQuests_questID = GetActiveQuestID(i)							
							--[[DevMode]]if SLH_QA_DevMode and SLH_ActiveQuests_questID ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("ActiveQuests_questID: " .. SLH_ActiveQuests_questID) end	
							local SLH_ActiveQuests_isComplete = C_QuestLog.IsComplete(SLH_ActiveQuests_questID)
							--[[DevMode]]if SLH_QA_DevMode and SLH_ActiveQuests_questID ~= nil then if SLH_ActiveQuests_isComplete then _G_SLH["SLH_SF"]["Config"]["Print"](SLH_ActiveQuests_questID .. " Complete") else _G_SLH["SLH_SF"]["Config"]["Print"](SLH_ActiveQuests_questID .. " Not Complete") end end
							
							if SLH_ActiveQuests_isComplete
							then 
								SelectActiveQuest(i)			
							end		
						end		
					end	
					return
				end
				
				local SLH_QA_CompleteQuests = function (SLH_QAOptions, event, name, questStartItemID, ...)	
					if IsAltKeyDown() then return end
					--[[DevMode]]if SLH_QA_DevMode and event ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("QA_CompleteQuests: " .. event) end
					C_Timer.After(_G_SLH["SLH_SV"][QA_Profile]["QA"]["QuestCompleteDelay"], function() CompleteQuest(questStartItemID) end)
					
					local SLH_numQuestChoices = GetNumQuestChoices()
					--[[DevMode]]if SLH_QA_DevMode and SLH_numQuestChoices ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("QA_CompleteQuests numQuestChoices: " .. SLH_numQuestChoices) end
					local SLH_ChoicesTable = {}
					local SLH_itemSellPriceChoicesTable = {}
					local SLH_UsableChoicesTable = {}
					local SLH_itemLevelChoicesTable = {}
					local SLH_itemEquipLocTable1 = {}
					local SLH_itemEquipLocTable2 = {}
					for i=1, SLH_numQuestChoices do			
						local SLH_name, 
							SLH_texture, 
							SLH_count, 
							SLH_quality, 
							SLH_isUsable = GetQuestItemInfo("choice", i)
					
						local SLH_Itemlink = GetQuestItemLink("choice", i)
							
						local SLH_itemName, 
							SLH_itemLink, 
							SLH_itemRarity, 
							SLH_itemLevel, 
							SLH_itemMinLevel, 
							SLH_itemType, 
							SLH_itemSubType, 
							SLH_itemStackCount,
							SLH_itemEquipLoc, 
							SLH_itemIcon, 
							SLH_itemSellPrice, 
							SLH_itemClassID, 
							SLH_itemSubClassID, 
							SLH_bindType, 
							SLH_expacID, 
							SLH_itemSetID, 
							SLH_isCraftingReagent = GetItemInfo(SLH_Itemlink) 
						
						local SLH_itemID, 
							SLH_itemType, 
							SLH_itemSubType, 
							SLH_itemEquipLoc, 
							SLH_icon, 
							SLH_itemClassID, 
							SLH_itemSubClassID = GetItemInfoInstant(SLH_Itemlink) 
							
						local SLH_effectiveILvl, 
							SLH_isPreview, 
							SLH_baseILvl = GetDetailedItemLevelInfo(SLH_Itemlink)
							
						local SLH_itemSlotTable = {
						  ["INVTYPE_AMMO"] =           { 0 },
						  ["INVTYPE_HEAD"] =           { 1 },
						  ["INVTYPE_NECK"] =           { 2 },
						  ["INVTYPE_SHOULDER"] =       { 3 },
						  ["INVTYPE_BODY"] =           { 4 },
						  ["INVTYPE_CHEST"] =          { 5 },
						  ["INVTYPE_ROBE"] =           { 5 },
						  ["INVTYPE_WAIST"] =          { 6 },
						  ["INVTYPE_LEGS"] =           { 7 },
						  ["INVTYPE_FEET"] =           { 8 },
						  ["INVTYPE_WRIST"] =          { 9 },
						  ["INVTYPE_HAND"] =           { 10 },
						  ["INVTYPE_FINGER"] =         { 11, 12 },
						  ["INVTYPE_TRINKET"] =        { 13, 14 },
						  ["INVTYPE_CLOAK"] =          { 15 },
						  ["INVTYPE_WEAPON"] =         { 16, 17 },
						  ["INVTYPE_SHIELD"] =         { 17 },
						  ["INVTYPE_2HWEAPON"] =       { 16 },
						  ["INVTYPE_WEAPONMAINHAND"] = { 16 },
						  ["INVTYPE_WEAPONOFFHAND"] =  { 17 },
						  ["INVTYPE_HOLDABLE"] =       { 17 },
						  ["INVTYPE_RANGED"] =         { 18 },
						  ["INVTYPE_THROWN"] =         { 18 },
						  ["INVTYPE_RANGEDRIGHT"] =    { 18 },
						  ["INVTYPE_RELIC"] =          { 18 }
						}				
						for key, value in pairs(SLH_itemSlotTable) do 
							if key == SLH_itemEquipLoc
							then
								SLH_RewardItemSlotID1 = value[1]
								SLH_RewardItemSlotID2 = value[2]
							end
						end			
						
						--Returns the item id of the item in the specified inventory slot
						local SLH_EquipedItemLink1 = GetInventoryItemLink("player", SLH_RewardItemSlotID1)
						local SLH_EquipedItemLink2 = GetInventoryItemLink("player", SLH_RewardItemSlotID2)
						
						if SLH_EquipedItemLink1
						then
							local SLH_EquippeditemName1, 
								SLH_EquippeditemLink1, 
								SLH_EquippeditemRarity1, 
								SLH_EquippeditemLevel1, 
								SLH_EquippeditemMinLevel1, 
								SLH_EquippeditemType1, 
								SLH_EquippeditemSubType1, 
								SLH_EquippeditemStackCount1,
								SLH_EquippeditemEquipLoc1, 
								SLH_EquippeditemIcon1, 
								SLH_EquippeditemSellPrice1, 
								SLH_EquippeditemClassID1, 
								SLH_EquippeditemSubClassID1, 
								SLH_EquippedbindType1, 
								SLH_EquippedexpacID1, 
								SLH_EquippeditemSetID1, 
								SLH_EquippedisCraftingReagent1 = GetItemInfo(SLH_EquipedItemLink1) 	
								
							local SLH_EquippedeffectiveILvl1, 
								SLH_EquippedisPreview1, 
								SLH_EquippedbaseILvl1 = GetDetailedItemLevelInfo(SLH_EquipedItemLink1)			
						end
						
						if SLH_EquipedItemLink2
						then
							local SLH_EquippeditemName2, 
								SLH_EquippeditemLink2, 
								SLH_EquippeditemRarity2, 
								SLH_EquippeditemLevel2, 
								SLH_EquippeditemMinLevel2, 
								SLH_EquippeditemType2, 
								SLH_EquippeditemSubType2, 
								SLH_EquippeditemStackCount2,
								SLH_EquippeditemEquipLoc2, 
								SLH_EquippeditemIcon2, 
								SLH_EquippeditemSellPrice2, 
								SLH_EquippeditemClassID2, 
								SLH_EquippeditemSubClassID2, 
								SLH_EquippedbindType2, 
								SLH_EquippedexpacID2, 
								SLH_EquippeditemSetID2, 
								SLH_EquippedisCraftingReagent2 = GetItemInfo(SLH_EquipedItemLink2) 
								
							local SLH_EquippedeffectiveILvl2, 
								SLH_EquippedisPreview2, 
								SLH_EquippedbaseILvl2 = GetDetailedItemLevelInfo(SLH_EquipedItemLink2)
						end	
						
						
						
						local SLH_ItemLevelDifference1 = 0
						local SLH_ItemLevelDifference2 = 0
						if not(SLH_EquippedeffectiveILvl1 == nil) then SLH_ItemLevelDifference1 = SLH_effectiveILvl - SLH_EquippedeffectiveILvl1 end
						if not(SLH_EquippedeffectiveILvl2 == nil) then SLH_ItemLevelDifference2 = SLH_effectiveILvl - SLH_EquippedeffectiveILvl2 end
						if SLH_ItemLevelDifference1 > SLH_ItemLevelDifference2
						then
							SLH_ItemLevelDifference = SLH_ItemLevelDifference1
						else
							SLH_ItemLevelDifference = SLH_ItemLevelDifference2
						end
											
						SLH_ChoicesTable[i]=i
						SLH_UsableChoicesTable[i]=SLH_isUsable 
						SLH_itemSellPriceChoicesTable[i]=SLH_itemSellPrice 
						SLH_itemLevelChoicesTable[i]=SLH_ItemLevelDifference 
						SLH_itemEquipLocTable1[i]=SLH_RewardItemSlotID1 
						SLH_itemEquipLocTable2[i]=SLH_RewardItemSlotID2
					end

				
					local SLH_ChoiceCount = 0
					for _ in pairs(SLH_ChoicesTable) do 
						SLH_ChoiceCount = SLH_ChoiceCount + 1 
					end
					
					local SLH_itemEquipLoc_Weapon = "N"
					for i, v in ipairs(SLH_itemEquipLocTable1) do 
						--[[DevMode]]if SLH_QA_DevMode and i ~= nil and v ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("QA_CompleteQuests CompleteQuests: SLH_itemEquipLocTable1: " .. i .. ", " .. v) end
						if (v == 16 or v == 17 or v == 18)
						then									
							SLH_itemEquipLoc_Weapon = "Y"
							--[[DevMode]]if SLH_QA_DevMode and SLH_itemEquipLoc_Weapon ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("QA_CompleteQuests CompleteQuests: SLH_itemEquipLoc_Weapon: " .. SLH_itemEquipLoc_Weapon) end
						end
					end	
					for i, v in ipairs(SLH_itemEquipLocTable2) do 
						--[[DevMode]]if SLH_QA_DevMode and i ~= nil and v ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("QA_CompleteQuests CompleteQuests: SLH_itemEquipLocTable2: " .. i .. ", " .. v) end
						if (v == 16 or v == 17 or v == 18)
						then									
							SLH_itemEquipLoc_Weapon = "Y"
							--[[DevMode]]if SLH_QA_DevMode and SLH_itemEquipLoc_Weapon ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("QA_CompleteQuests CompleteQuests: SLH_itemEquipLoc_Weapon: " .. SLH_itemEquipLoc_Weapon) end
						end
					end			
								
			
					if _G_SLH["SLH_SV"][QA_Profile]["QA"]["AutoSelectRewards"] == "Y" 
					then
						if  SLH_ChoiceCount <= 1 
						then 		
							
							if QuestFrameCompleteQuestButton:IsVisible() then QuestFrameCompleteQuestButton:Click() end
							if QuestFrameCompleteButton:IsVisible() then QuestFrameCompleteButton:Click() end
						elseif _G_SLH["SLH_SV"][QA_Profile]["QA"]["ExcludeWeapons"] == "Y" and SLH_itemEquipLoc_Weapon == "Y"
						then												
							_G_SLH["SLH_SF"]["Config"]["Print"]("Automated Weapon Selection Excluded: Quest Automation Paused for Weapon Reward Selection. Please Select Reward and Click Complete Quest.")
							return
						elseif _G_SLH["SLH_SV"][QA_Profile]["QA"]["QuestRewardSelectionCriteria"] == "Highest Vendor Sell Price"
						then									
							for index, value in pairs(SLH_itemSellPriceChoicesTable) do 
								if index == 1 
								then 
									SLH_HighestitemSellPrice = value 
									SLH_HighestitemSellPriceIndex = index
								elseif SLH_HighestitemSellPrice < value
								then 
									SLH_HighestitemSellPrice = value 
									SLH_HighestitemSellPriceIndex = index
								end
							end
							C_Timer.After(_G_SLH["SLH_SV"][QA_Profile]["QA"]["QuestRewardSelectDelay"], function() GetQuestReward(SLH_HighestitemSellPriceIndex) end)
						elseif _G_SLH["SLH_SV"][QA_Profile]["QA"]["QuestRewardSelectionCriteria"] == "Largest Item Level Upgrade"
						then								
							for index, value in pairs(SLH_itemLevelChoicesTable) do 
								if index == 1 
								then 
									SLH_LargestItemLevelUpgrade = value 
									SLH_LargestItemLevelUpgradeIndex = index
								elseif SLH_LargestItemLevelUpgrade < value
								then 
									SLH_LargestItemLevelUpgrade = value 
									SLH_LargestItemLevelUpgradeIndex = index
								end
							end						
							C_Timer.After(_G_SLH["SLH_SV"][QA_Profile]["QA"]["QuestRewardSelectDelay"], function() GetQuestReward(SLH_LargestItemLevelUpgradeIndex) end)
						else
							_G_SLH["SLH_SF"]["Config"]["Print"]("No Automated Criteria Selected: Quest Automation Paused for Reward Selection. Please Select Reward and Click Complete Quest.")
						end
					else
						if _G_SLH["SLH_SV"][QA_Profile]["QA"]["ShowAutoSelectDisabledMessage"] == "Y"
						then
							_G_SLH["SLH_SF"]["Config"]["Print"]("Automated Criteria Disabled: Quest Automation Paused for Reward Selection. Please Select Reward and Click Complete Quest.")
						end
					end
					return
				end

			--Share Accepted Quests
				local SLH_QA_ShareAcceptedQuests = function (SLH_QAOptions, event, questID, ...)
					if IsInGroup() and _G_SLH["SLH_SV"][QA_Profile]["QA"]["QuestSharing"] == "Y" 
					then
						local SLH_QuestLogIndex = C_QuestLog.GetLogIndexForQuestID(questID)
						if SLH_QuestLogIndex == nil 
						then 
							if SLH_QuestLogTitle ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("Tried to Share Quest: '" .. SLH_QuestLogTitle .. "'.  Quest is not Shareable.") end
							return
						end
						local SLH_QuestLogInfo = C_QuestLog.GetInfo(SLH_QuestLogIndex)
						local SLH_QuestLogTitle = SLH_QuestLogInfo.title
						if C_QuestLog.IsPushableQuest(questID)
						then
							C_QuestLog.SetSelectedQuest(questID)
							QuestLogPushQuest()
						else
							if SLH_QuestLogTitle ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("Tried to Share Quest: '" .. SLH_QuestLogTitle .. "'.  Quest is not Shareable.") end
						end
					end
					return
				end

			--Accept Quests
				local SLH_QA_AvailableQuests = function (SLH_QAOptions, event, name, questStartItemID, ...)
					if IsAltKeyDown() then return end	
					--[[DevMode]]if SLH_QA_DevMode and event ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("QA_AvailableQuests AvailableQuests: " .. event) end
					
					local SLH_NumGossipAvailableQuests = C_GossipInfo.GetNumAvailableQuests()		
					--[[DevMode]]if SLH_QA_DevMode and SLH_NumGossipAvailableQuests ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("QA_AvailableQuests NumGossipAvailableQuests: " .. SLH_NumGossipAvailableQuests) end	
							
					local SLH_NumAvailableQuests = GetNumAvailableQuests()			
					--[[DevMode]]if SLH_QA_DevMode and SLH_NumAvailableQuests ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("QA_AvailableQuests SLH_NumAvailableQuests: " .. SLH_NumAvailableQuests) end								
		
					if not(SLH_NumGossipAvailableQuests == nil) and SLH_NumGossipAvailableQuests > 0
					then
						local SLH_NumGossipAvailableQuestsGetOptionsTable = C_GossipInfo.GetOptions()
						for i=1, SLH_NumGossipAvailableQuests do
							--Is Quest in quest Log?
							local SLH_GossipAvailableQuests_questID = C_GossipInfo.GetAvailableQuests()[i].questID		
							--Skip these quests:
								--"The Cost of Death"(64541)  --Repetitive turn in, uses all your Stygia 
									if SLH_GossipAvailableQuests_questID == 64541 then _G_SLH["SLH_SF"]["Config"]["Print"]("QA: skipped 'The Cost of Death'") return end
						
										
							--[[DevMode]]if SLH_QA_DevMode and SLH_GossipAvailableQuests_questID ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("QA_AvailableQuests AvailableQuests_questID: " .. SLH_GossipAvailableQuests_questID) end	
							local SLH_GossipAvailableQuests_questLogIndex = C_QuestLog.GetLogIndexForQuestID(SLH_GossipAvailableQuests_questID)												
							--[[DevMode]]if SLH_QA_DevMode and SLH_GossipAvailableQuests_questID ~= nil then if SLH_GossipAvailableQuests_questLogIndex then _G_SLH["SLH_SF"]["Config"]["Print"](SLH_GossipAvailableQuests_questID .. " In Quest Log") else _G_SLH["SLH_SF"]["Config"]["Print"](SLH_GossipAvailableQuests_questID .. " Not In Quest Log") end end
							
							if not SLH_GossipAvailableQuests_questLogIndex
							then 	
								C_GossipInfo.SelectAvailableQuest(i)
							end					
						end
					elseif not(SLH_NumAvailableQuests == nil) and SLH_NumAvailableQuests > 0
					then
						for i=1, SLH_NumAvailableQuests do	
							--Is Quest in quest Log?
							SLH_AvailableQuests_questTitle = GetAvailableTitle(i)		
							--[[DevMode]]if SLH_QA_DevMode and SLH_AvailableQuests_questTitle ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("AvailableQuests_questTitle: " .. SLH_AvailableQuests_questTitle) end	
							
							SLH_AvailableQuests_numShownEntries, SLH_AvailableQuests_numQuests = C_QuestLog.GetNumQuestLogEntries()
							
							if SLH_AvailableQuests_numShownEntries == nil then SLH_AvailableQuests_numShownEntries = 0 end
							if SLH_AvailableQuests_numQuests == nil then SLH_AvailableQuests_numQuests = 0 end
							
							if SLH_AvailableQuests_numShownEntries > SLH_AvailableQuests_numQuests
							then
								SLH_AvailableQuests_QuestLogCount = SLH_AvailableQuests_numShownEntries
							else
								SLH_AvailableQuests_QuestLogCount = SLH_AvailableQuests_numQuests
							end
							
							SLH_AvailableQuests_QuestinQuestLog = 0
							for i=1, SLH_AvailableQuests_QuestLogCount do
								SLH_AvailableQuests_QuestLogTitle = C_QuestLog.GetTitleForLogIndex(i)					
								--[[DevMode]]if SLH_QA_DevMode and SLH_AvailableQuests_QuestLogTitle ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("AvailableQuests_QuestLogTitle: " .. SLH_AvailableQuests_QuestLogTitle) end	
								if SLH_AvailableQuests_questTitle == SLH_AvailableQuests_QuestLogTitle
								then 
									SelectAvailableQuest(i) 	
								end					
							end
					
							if SLH_AvailableQuests_QuestinQuestLog == 0
							then 
								SelectAvailableQuest(i)	
							end
						end
					end
					return
				end
				
				local SLH_QA_AcceptQuests = function (SLH_QAOptions, event, name, questStartItemID, ...)	
					if IsAltKeyDown() then return end
					--[[DevMode]]if SLH_QA_DevMode and event ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("QA_AcceptQuests AcceptQuests: " .. event) end
					local SLH_AcceptQuests_questID = GetQuestID()
					C_Timer.After(_G_SLH["SLH_SV"][QA_Profile]["QA"]["QuestAcceptDelay"], function() AcceptQuest(questStartItemID) end)
					
					C_QuestLog.SetSelectedQuest(SLH_AcceptQuests_questID)
					SLH_AcceptQuests_SetSelectedQuestquestID = C_QuestLog.GetSelectedQuest()
					
					QuestLogPushQuest()
					return
				end
				

		--SLH_NC Module Scan
			local SLH_QA_Scan = function (self, event, ...)	
		
				--[[DevMode]]if SLH_QA_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: SLH_QA_Module_Scan Start") end		
				local SLH_Bags = {}	
				SLH_Bags[1]=0
				SLH_Bags[2]=1
				SLH_Bags[3]=2
				SLH_Bags[4]=3
				SLH_Bags[5]=4
				for index, SLH_bagID in ipairs(SLH_Bags) do
					local SLH_Bag_numberOfSlots = GetContainerNumSlots(SLH_bagID)
					for SLH_slot = 1, SLH_Bag_numberOfSlots do
						local SLH_icon, 
							SLH_itemCount,
							SLH_locked, 
							SLH_quality, 
							SLH_readable, 
							SLH_lootable, --Lockbox ID?
							SLH_itemLink, 
							SLH_isFiltered, 
							SLH_noValue, 
							SLH_itemID = GetContainerItemInfo(SLH_bagID, SLH_slot)
							
						if SLH_itemLink ~= nil
						then 
							local SLH_QA_lootstring = string.match(SLH_itemLink, "item[%-?%d:]+")
							SLH_QA_Module(self, event, SLH_itemLink, SLH_QA_lootstring)
						end
					end
				end
				return
			end
			

		--SLH_QA EventCall
			local SLH_QA_Events = function (SLH_QAOptions, event, name, ...)
				--[[DevMode]]if SLH_QA_DevMode and event ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("QA_Events: " .. event) end
				if _G_SLH["SLH_SV"][QA_Profile]["QA"]["DisableAtMaxLevel"] == "Y" and UnitLevel("player") == 60 then return end
				
				--Run_SLH_AvailableQuests
					Run_SLH_AvailableQuests = CreateFrame("Frame","Run_SLH_AvailableQuests")
					Run_SLH_AvailableQuests:RegisterEvent("GOSSIP_SHOW")
					Run_SLH_AvailableQuests:RegisterEvent("QUEST_GREETING")
					if _G_SLH["SLH_SV"][QA_Profile]["QA"]["Enable"] == "Y"
						then Run_SLH_AvailableQuests:HookScript("OnEvent", SLH_QA_AvailableQuests)
					end
					
				--Run_SLH_AcceptQuests
					Run_SLH_AcceptQuests = CreateFrame("Frame","Run_SLH_AcceptQuests")
					Run_SLH_AcceptQuests:RegisterEvent("QUEST_DETAIL")
					if _G_SLH["SLH_SV"][QA_Profile]["QA"]["Enable"] == "Y"
						then Run_SLH_AcceptQuests:HookScript("OnEvent", SLH_QA_AcceptQuests)
					end
						
				--Run_SLH_ActiveQuests
					Run_SLH_ActiveQuests = CreateFrame("Frame","Run_SLH_ActiveQuests")
					Run_SLH_ActiveQuests:RegisterEvent("GOSSIP_SHOW")
					Run_SLH_ActiveQuests:RegisterEvent("QUEST_GREETING")
					if _G_SLH["SLH_SV"][QA_Profile]["QA"]["Enable"] == "Y"
						then Run_SLH_ActiveQuests:HookScript("OnEvent", SLH_QA_ActiveQuests)
					end
					
				--Run_SLH_CompleteQuests
					Run_SLH_CompleteQuests = CreateFrame("Frame","Run_SLH_CompleteQuests")
					Run_SLH_CompleteQuests:RegisterEvent("QUEST_PROGRESS")
					Run_SLH_CompleteQuests:RegisterEvent("QUEST_COMPLETE")
					if _G_SLH["SLH_SV"][QA_Profile]["QA"]["Enable"] == "Y"
						then Run_SLH_CompleteQuests:HookScript("OnEvent", SLH_QA_CompleteQuests)
					end
						
				--Run_SLH_ShareAcceptedQuests
					Run_SLH_ShareAcceptedQuests = CreateFrame("Frame","Run_SLH_ShareAcceptedQuests")
					Run_SLH_ShareAcceptedQuests:RegisterEvent("QUEST_ACCEPTED")
					if _G_SLH["SLH_SV"][QA_Profile]["QA"]["Enable"] == "Y"
						then Run_SLH_ShareAcceptedQuests:HookScript("OnEvent", SLH_QA_ShareAcceptedQuests)
					end	
				
				--Run_SLH_QA_GossipText
					Run_SLH_QA_GossipText = CreateFrame("Frame","Run_SLH_QA_GossipText")
					Run_SLH_QA_GossipText:RegisterEvent("GOSSIP_SHOW")
					Run_SLH_QA_GossipText:RegisterEvent("QUEST_GREETING")
					if _G_SLH["SLH_SV"][QA_Profile]["QA"]["Enable"] == "Y"
						then Run_SLH_QA_GossipText:HookScript("OnEvent", SLH_QA_GossipText)
					end

				return
			end

		--SLH_QA Config Screen
			local SLH_QA_Frames = function  (self, event, name, ...)

				-- SLH_QA Options
					local SLH_QAOptions = CreateFrame( "Frame", "SLH_QAOptions")
					SLH_QAOptions.name = "Quest Automation"
					-- Specify childness of this panel (this puts it under the little red [+], instead of giving it a normal AddOn category)
						SLH_QAOptions.parent = SLH_Config_Panel.name
					-- Add the child to the Interface Options
						InterfaceOptions_AddCategory(SLH_QAOptions)
					--Add Title
						local SLH_QAOptionsTitle = SLH_QAOptions:CreateFontString(nil, "ARTWORK","GameFontNormalLarge")
						SLH_QAOptionsTitle:SetPoint("TOPLEFT", 10, -10)
						SLH_QAOptionsTitle:SetText("Salen's Little Helper - Quest Automation Options")

			
				--SLH_QADetail - Create Scroll Frame		
					SLH_QADetail = securecall(_G_SLH["SLH_SF"]["SLH_CreateScrollFrame"],SLH_QAOptions, --self
						"SLH_QADetail", --FrameName
						SLH_QAOptions, --relativeFrame
						5, --xOffset
						-30, --yOffset
						SLH_QAOptions, --relativeFrame
						-5, --xOffset
						5,--yOffset
						"Quest Automation Options" -- Title
						)
					SLH_QADetail.ScrollBar:ClearAllPoints()
					SLH_QADetail.ScrollBar:SetPoint("TOPLEFT", SLH_QADetail, "TOPRIGHT", -25, -20)
					SLH_QADetail.ScrollBar:SetPoint("BOTTOMRIGHT", SLH_QADetail, "BOTTOMRIGHT", -5, 25)
					SLH_QADetail:SetClipsChildren(true)		
					
					--(Uncomment to) Set Background Color
						--SLH_QADetail.bg = SLH_QADetail:CreateTexture(nil, "BACKGROUND")
						--SLH_QADetail.bg:SetAllPoints(true)
						--SLH_QADetail.bg:SetColorTexture(0.8, 0.4, 0, 0.2)
					--End Set Background Color

					--SLH_QADetailScrollFrameChild
						local SLH_QADetailScrollFrameChild = CreateFrame("Frame", nil, SLH_QADetail)
						SLH_QADetailScrollFrameChild:SetSize(600, 470)
							--(Uncomment to) Set Background Color
								--SLH_QADetailScrollFrameChild.bg = SLH_QADetailScrollFrameChild:CreateTexture(nil, "BACKGROUND")
								--SLH_QADetailScrollFrameChild.bg:SetAllPoints(true)
								--SLH_QADetailScrollFrameChild.bg:SetColorTexture(0.2, 0.6, 0, 0.8)
							--End Set Background Color
						SLH_QADetail:SetScrollChild(SLH_QADetailScrollFrameChild)	
						SLH_QADetailScrollFrameChild:SetClipsChildren(true)		
			
					

					--SLH_QADetail Title 
						SLH_QADetailScrollFrameChild.title = SLH_QADetailScrollFrameChild:CreateFontString (nil, "OVERLAY")
						SLH_QADetailScrollFrameChild.title:SetFontObject("GameFontHighlight")
						SLH_QADetailScrollFrameChild.title:SetPoint("LEFT", SLH_QADetailScrollFrameChild.TitleBg, "LEFT", 5, 0)
						SLH_QADetailScrollFrameChild.title:SetText("Quest Automation Options")	
						SLH_QADetailScrollFrameChild.title:SetTextColor(_G_SLH["SLH_SF"]["SLH_TitleColors"].r, _G_SLH["SLH_SF"]["SLH_TitleColors"].g, _G_SLH["SLH_SF"]["SLH_TitleColors"].b, _G_SLH["SLH_SF"]["SLH_TitleColors"].a)					

					--MasterFrame.SLH_QADetail Buttons
						-- Enable_SLH_QA Check Button:
							Enable_SLH_QA = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_QAOptions, --self
								"TOPLEFT", --point
								SLH_QADetailScrollFrameChild, --relativeFrame
								"Enable_SLH_QA", --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								10, --xOffset
								-20, --yOffset
								"SLH_SV", --SVPath0
								QA_Profile, --SVPath1
								"QA", --SVPath2
								"Enable", --SVPath3
								"Enable Quest Automation", --text
								"Will Auto Accept all quests on interaction with Quest giver\n\nHolding Alt key disables Quest Automation on the fly" --tooltip
								)
								Enable_SLH_QA:HookScript("OnClick", function(self, arg1)			
									if Enable_SLH_QA:GetChecked() 
										then 
											_G_SLH["SLH_SV"][QA_Profile]["QA"]["Enable"] = "Y"
											SLH_QA_SetVars(self, event, name)
											SLH_QA_Events(self, event, name)
										else 
											_G_SLH["SLH_SV"][QA_Profile]["QA"]["Enable"] = "N"
											--if _G_SLH["SLH_SV"][QA_Profile]["QA"]["DisableAtMaxLevel"] == "Y" and UnitLevel("player") == 60 then return end
											
											if Run_SLH_ActiveQuests then Run_SLH_ActiveQuests:UnregisterAllEvents()	end
											if Run_SLH_CompleteQuests then Run_SLH_CompleteQuests:UnregisterAllEvents()	end
											if Run_SLH_AvailableQuests then Run_SLH_AvailableQuests:UnregisterAllEvents()	end
											if Run_SLH_AcceptQuests then Run_SLH_AcceptQuests:UnregisterAllEvents()	end				
									end
								end)
										
						-- Enable_SLH_QA - in seconds
							SLH_QA_QuestListDelay = securecall(_G_SLH["SLH_SF"]["SLH_CreateSlider"],SLH_QAOptions, --
								"TOPLEFT", --point
								Enable_SLH_QA, --relativeFrame
								"SLH_QA_QuestListDelay" , --FrameName
								"BOTTOMLEFT", --relativePoint
								10, --xOffset
								-40, --yOffset
								0, --Min
								5, --Max
								_G_SLH["SLH_SV"][QA_Profile]["QA"]["QuestListDelay"], --Value
								.05, --Step
								"SLH_SV", --SVPath0
								QA_Profile, --SVPath1
								"QA", --SVPath2
								"QuestListDelay", --SVPath3
								"Quest List Delay", --text
								"Set Quest List Delay\n\nQuest List is the first screen showing the list of all available quests\n\nDefault 0 seconds" --tooltip
								)
										
						-- SLH_QA_QuestAcceptDelay - in seconds
							SLH_QA_QuestAcceptDelay = securecall(_G_SLH["SLH_SF"]["SLH_CreateSlider"],SLH_QAOptions, --
								"TOPLEFT", --point
								SLH_QA_QuestListDelay, --relativeFrame
								"SLH_QA_QuestAcceptDelay" , --FrameName
								"BOTTOMLEFT", --relativePoint
								0, --xOffset
								-50, --yOffset
								0, --Min
								5, --Max
								_G_SLH["SLH_SV"][QA_Profile]["QA"]["QuestAcceptDelay"], --Value
								.05, --Step
								"SLH_SV", --SVPath0
								QA_Profile, --SVPath1
								"QA", --SVPath2
								"QuestAcceptDelay", --SVPath3
								"Quest Accept Delay", --text
								"Set Quest Accept Delay\n\nQuest Accept is the screen showing the Quest Details\n\nDefault 0 seconds" --tooltip
								)
										
						-- SLH_QA_QuestCompleteDelay - in seconds
							SLH_QA_QuestCompleteDelay = securecall(_G_SLH["SLH_SF"]["SLH_CreateSlider"],SLH_QAOptions, --
								"TOPLEFT", --point
								SLH_QA_QuestAcceptDelay, --relativeFrame
								"SLH_QA_QuestCompleteDelay" , --FrameName
								"BOTTOMLEFT", --relativePoint
								0, --xOffset
								-50, --yOffset
								0, --Min
								5, --Max
								_G_SLH["SLH_SV"][QA_Profile]["QA"]["QuestCompleteDelay"], --Value
								.05, --Step
								"SLH_SV", --SVPath0
								QA_Profile, --SVPath1
								"QA", --SVPath2
								"QuestCompleteDelay", --SVPath3
								"Quest Complete Delay", --text
								"Set Quest Complete Delay\n\nQuest Complete is NOT finishing the quest. It is the screen where you hit continue to get to the quest rewards\n\nDefault 0 seconds" --tooltip
								)
										
						-- SLH_QA_QuestRewardSelectDelay - in seconds
							SLH_QA_QuestRewardSelectDelay = securecall(_G_SLH["SLH_SF"]["SLH_CreateSlider"],SLH_QAOptions, --
								"TOPLEFT", --point
								SLH_QA_QuestCompleteDelay, --relativeFrame
								"SLH_QA_QuestRewardSelectDelay" , --FrameName
								"BOTTOMLEFT", --relativePoint
								0, --xOffset
								-50, --yOffset
								0, --Min
								5, --Max
								_G_SLH["SLH_SV"][QA_Profile]["QA"]["QuestRewardSelectDelay"], --Value
								.05, --Step
								"SLH_SV", --SVPath0
								QA_Profile, --SVPath1
								"QA", --SVPath2
								"QuestRewardSelectDelay", --SVPath3
								"Quest Reward Delay", --text
								"Set Quest Reward Selection Delay\n\nQuest Reward is the screen where you Select a Reward if there are Choices, and then Click Complete.\n\nDefault 0 seconds" --tooltip
								)
								
						-- SLH_QA_AutoSelectRewards Check Button:
							SLH_QA_AutoSelectRewards = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_QAOptions, --self
								"TOPLEFT", --point
								SLH_QA_QuestRewardSelectDelay, --relativeFrame
								"SLH_QA_AutoSelectRewards", --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								-10, --xOffset
								-40, --yOffset
								"SLH_SV", --SVPath0
								QA_Profile, --SVPath1
								"QA", --SVPath2
								"AutoSelectRewards", --SVPath3
								"Auto Select Rewards", --text
								"Automatically select Quest Rewards based on the criteria chosen?\n\nCaveat Emptor: Be aware this involves risk.  The reward selection is auto selected based on your choice.  You may not get what you want. Probably fine for Heirloom users others may or may not want to use this.\n\nWeapons will not be auto selected." --tooltip
								)									
								
								local SLH_QA_QuestRewardSelectionCriteriaTable = {}
								SLH_QA_QuestRewardSelectionCriteriaTable[1] = "Highest Vendor Sell Price"
								SLH_QA_QuestRewardSelectionCriteriaTable[2] = "Largest Item Level Upgrade"
								
								
						-- Set Title Text
							if _G_SLH["SLH_SV"][QA_Profile]["QA"]["QuestRewardSelectionCriteria"] == nil 
							then 
								_G_SLH["SLH_SF"]["QuestRewardSelectionCriteriaTitle"] = "Select Quest Reward Selection Method"
							else 
								_G_SLH["SLH_SF"]["QuestRewardSelectionCriteriaTitle"] = _G_SLH["SLH_SV"][QA_Profile]["QA"]["QuestRewardSelectionCriteria"]
							end
							
						--Create DropDown 	
							securecall(_G_SLH["SLH_SF"]["SLH_CreateDropDownList"],SLH_QAOptions, --self
								"TOPLEFT", --point 
								SLH_QA_AutoSelectRewards, --relativeFrame
								SLH_QA_QuestRewardSelectionCriteria, --FrameName
								"SLH_QA_QuestRewardSelectionCriteria", --FrameNameText
								"TOPLEFT", --relativePoint
								200, --Width
								0, --xOffset
								-20, --yOffset						
								"SLH_SV", --SVPath0
								QA_Profile, --SVPath1
								"QA", --SVPath2
								"QuestRewardSelectionCriteria", --SVPath3
								_G_SLH["SLH_SF"]["QuestRewardSelectionCriteriaTitle"], --text
								SLH_QA_QuestRewardSelectionCriteriaTable, --DropDownListTable
								"SLH_QA_QuestRewardSelectionCriteriaDropDown_ContextMenu", --ContextMenuName
								SLH_QADetailScrollFrameChild, --ContextMenuParent
								"MENU", --ContextOrDropDown - "MENU" = Context anything else is dropdown
								"Dynamic" --Static vs Dynamically created List?
								)	
								
						-- SLH_QA_ExcludeWeapons Check Button:
							SLH_QA_ExcludeWeapons = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_QAOptions, --self
								"TOPLEFT", --point
								SLH_QA_QuestRewardSelectionCriteria, --relativeFrame
								"SLH_QA_ExcludeWeapons", --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								0, --xOffset
								-30, --yOffset
								"SLH_SV", --SVPath0
								QA_Profile, --SVPath1
								"QA", --SVPath2
								"ExcludeWeapons", --SVPath3
								"Exclude Weapons when Auto Selecting Rewards?", --text
								"Exclude Weapons when Auto Selecting Rewards? Forces choosing your quest reward for weapons, as a simple item level compare does not cover enough weapon selection variables to be useful." --tooltip
								)	
								
						-- SLH_QA_ShowAutoSelectDisabledMessage Check Button:
							SLH_QA_ShowAutoSelectDisabledMessage = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_QAOptions, --self
								"TOPLEFT", --point
								SLH_QA_ExcludeWeapons, --relativeFrame
								"SLH_QA_ShowAutoSelectDisabledMessage", --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								0, --xOffset
								-40, --yOffset
								"SLH_SV", --SVPath0
								QA_Profile, --SVPath1
								"QA", --SVPath2
								"ShowAutoSelectDisabledMessage", --SVPath3
								"Show Auto Select Rewards Disabled Message", --text
								"Shows a message indicating that Auto selecting of Rewards is disabled so you need to choose your quest reward, and complete the quest." --tooltip
								)
								
						--Right Side
								
						-- SLH_QA_DisableAtMaxLevel Check Button:
							SLH_QA_DisableAtMaxLevel = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_QAOptions, --self
								"TOPLEFT", --point
								Enable_SLH_QA, --relativeFrame
								"SLH_QA_DisableAtMaxLevel", --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								280, --xOffset
								0, --yOffset
								"SLH_SV", --SVPath0
								QA_Profile, --SVPath1
								"QA", --SVPath2
								"DisableAtMaxLevel", --SVPath3
								"Disable Quest Automation at Max Level?", --text
								"Disables Quest Automation when you character reaches Max Level for your account\n\nAllows you to keep your current settings and not worry about lost quest rewards at max level.\n\nThis setting requires a reload after a change." --tooltip
								)
								
						-- SLH_QA_QuestSharing Check Button:
							SLH_QA_QuestSharing = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_QAOptions, --self
								"TOPLEFT", --point
								SLH_QA_DisableAtMaxLevel, --relativeFrame
								"SLH_QA_QuestSharing", --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								0, --xOffset
								-20, --yOffset
								"SLH_SV", --SVPath0
								QA_Profile, --SVPath1
								"QA", --SVPath2
								"QuestSharing", --SVPath3
								"Enable Automated Quest Sharing?", --text
								"Enables Automated Quest Sharing\n\nWill attempt to share all quests you accept\n\nShows a message when sharing fails." --tooltip
								)
								
						-- SLH_QA_GossipText Check Button:
							SLH_QA_GossipText = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_QAOptions, --self
								"TOPLEFT", --point
								SLH_QA_QuestSharing, --relativeFrame
								"SLH_QA_GossipText", --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								0, --xOffset
								-20, --yOffset
								"SLH_SV", --SVPath0
								QA_Profile, --SVPath1
								"QA", --SVPath2
								"GossipText", --SVPath3
								"Enable Automated Gossip Text Selection?", --text
								"Enables Automated Gossip Text Selection\n\nWill attempt to select the first gossip option after all Quest processes are completed.\n\nMay not always select what you what hold Alt when thing do not go as planned..." --tooltip
								)
								
										
			end

			
			if _G_SLH["SLH_PCSV"][SLH_PCSV_UnitName]["Config"]["QA_Load"] == "Y" then
				SLH_QA_SetVars(self, event, name, ...)
				SLH_QA_Events(self, event, name, ...)
			end
			if _G_SLH["SLH_PCSV"][SLH_PCSV_UnitName]["Config"]["QA_Hide"] == "N" then
				SLH_QA_Frames(self, event, name, ...)
			end
		
		
	end	)	