--Run SLH_Config_Lua  	
	SLH_NE_Lua = CreateFrame("Frame", "SLH_NE_Lua")
	SLH_NE_Lua:RegisterEvent("ADDON_LOADED")
	SLH_NE_Lua:HookScript("OnEvent", function (self, event, name, ...)
		if (name ~= "SalensLittleHelper") then return end

		--Theoretically speeds up access to global variables by making them local.  This is supposed to be faster.  I have no proof this is true.	
			local _G_SLH = _G 

		local SLH_PCSV_UnitName = _G_SLH["SLH_PCSV"]["SLH_PCSV_UnitNameGlobal"]
		local NE_Profile = _G_SLH["SLH_PCSV"][SLH_PCSV_UnitName]["Config"]["NE_Profile"]
			
		--Development Mode Boolean (Controls various Overrides, disable to test and distribute.)
			local SLH_NE_DevMode = false
			--[[DevMode]]if SLH_NE_DevMode and name ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE_Lua addonName: " .. name) end	


		-- Set Variables
			local SLH_NE_SetVars = function (self, event, name, ...)
				-- Test/Create SLH_SV Table			
					if _G_SLH["SLH_SV"] == nil then _G_SLH["SLH_SV"] = {} end			
				-- Test/Create SLH_SV.NE_Profile Table
					if _G_SLH["SLH_SV"][NE_Profile] == nil then _G_SLH["SLH_SV"][NE_Profile] = {}  end	
				-- Test/Create SLH_NE Table
					if _G_SLH["SLH_SV"][NE_Profile]["NE"] == nil then _G_SLH["SLH_SV"][NE_Profile]["NE"] = {}  end	
						
				-- Test/Create SLH_NE Variables
					if _G_SLH["SLH_SV"][NE_Profile]["NE"]["Enable"] == nil then _G_SLH["SLH_SV"][NE_Profile]["NE"]["Enable"] = "Y" end
					if _G_SLH["SLH_SV"][NE_Profile]["NE"]["xOfs"] == nil then _G_SLH["SLH_SV"][NE_Profile]["NE"]["xOfs"] = 0 end	
					if _G_SLH["SLH_SV"][NE_Profile]["NE"]["yOfs"] == nil then _G_SLH["SLH_SV"][NE_Profile]["NE"]["yOfs"] = 320 end			
					if _G_SLH["SLH_SV"][NE_Profile]["NE"]["framelevel"] == nil then _G_SLH["SLH_SV"][NE_Profile]["NE"]["framelevel"] = 9000 end	
					if _G_SLH["SLH_SV"][NE_Profile]["NE"]["DisableForCrafting"] == nil then _G_SLH["SLH_SV"][NE_Profile]["NE"]["DisableForCrafting"] = "Y" end
					if _G_SLH["SLH_SV"][NE_Profile]["NE"]["DisableWhenMailBoxIsOpen"] == nil then _G_SLH["SLH_SV"][NE_Profile]["NE"]["DisableWhenMailBoxIsOpen"] = "Y" end
					if _G_SLH["SLH_SV"][NE_Profile]["NE"]["DisableBOE"] == nil then _G_SLH["SLH_SV"][NE_Profile]["NE"]["DisableBOE"] = "Y" end
					if _G_SLH["SLH_SV"][NE_Profile]["NE"]["DisableLowerILevel"] == nil then _G_SLH["SLH_SV"][NE_Profile]["NE"]["DisableLowerILevel"] = "Y" end
					if _G_SLH["SLH_SV"][NE_Profile]["NE"]["AutoEquipByILevel"] == nil then _G_SLH["SLH_SV"][NE_Profile]["NE"]["AutoEquipByILevel"] = "Y" end
					if _G_SLH["SLH_SV"][NE_Profile]["NE"]["IgnoreHeirloomSlots"] == nil then _G_SLH["SLH_SV"][NE_Profile]["NE"]["IgnoreHeirloomSlots"] = "Y" end					
					if _G_SLH["SLH_SV"][NE_Profile]["NE"]["DisableAtMaxLevel"] == nil then _G_SLH["SLH_SV"][NE_Profile]["NE"]["DisableAtMaxLevel"] = "Y" end
					if _G_SLH["SLH_SV"][NE_Profile]["NE"]["LogOnScan"] == nil then _G_SLH["SLH_SV"][NE_Profile]["NE"]["LogOnScan"] = "Y" end
					
				--Reset Pauses on load
					_G_SLH["SLH_SV"][NE_Profile]["NE"]["PostCombatList"] = {}
					_G_SLH["SLH_SV"][NE_Profile]["NE"]["PausedWhileMailing"] = "N" 

			end
				
		--SLH_NE_Module Module
			local SLH_NE_Module = function (self, event, SLH_NE_itemLink, SLH_NE_lootstring)					
				
				if SLH_NE_itemLink ~= nil
				then
					--[[DevMode]]if SLH_NE_DevMode and SLH_NE_itemLink ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE_Module : " .. SLH_NE_itemLink) end	
				else
					return
				end
				
				local SLH_itemName, 
					SLH_itemLink_GetItemInfo, 
					SLH_itemRarity, 
					SLH_NE_GetItemInfo_itemLevel, 
					SLH_itemMinLevel, 
					SLH_itemType, -- 4 = Armor
					SLH_itemSubType, 
					SLH_itemStackCount,
					SLH_itemEquipLoc, 
					SLH_itemIcon, 
					SLH_itemSellPrice, 
					SLH_itemClassID, 
					SLH_itemSubClassID, 
					SLH_bindType, 
					SLH_expacID, 
					SLH_itemSetID, 
					SLH_isCraftingReagent = GetItemInfo(SLH_NE_itemLink) 
					
				local SLH_GetDetailedItemLevelInfo_effectiveILvl, 
					SLH_isPreview, 
					SLH_baseILvl = GetDetailedItemLevelInfo(SLH_NE_itemLink)
				
				if tonumber(SLH_itemMinLevel) ~= nil and tonumber(UnitLevel("player")) ~= nil and tonumber(SLH_itemMinLevel) > UnitLevel("player") 
				then 
					--[[DevMode]]if SLH_NE_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: SLH_itemMinLevel too High to equip") end
					return 
				end
				
				if SLH_bindType == 2 and _G_SLH["SLH_SV"][NE_Profile]["NE"]["DisableBOE"] == "Y"
				then
					--[[DevMode]]if SLH_NE_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: Item is BOE. Pop-ups disabled for BOE Items.") end
					return
				end
				
				--[[	
						Enum.ItemQuality
				Value			Key			GlobalString (enUS)
				0	Poor		Poor		ITEM_QUALITY0_DESC
				1	Common		Common		ITEM_QUALITY1_DESC
				2	Uncommon	Uncommon	ITEM_QUALITY2_DESC
				3	Rare		Rare		ITEM_QUALITY3_DESC
				4	Epic		Epic		ITEM_QUALITY4_DESC
				5	Legendary	Legendary	ITEM_QUALITY5_DESC
				6	Artifact	Artifact	ITEM_QUALITY6_DESC
				7	Heirloom	Heirloom	ITEM_QUALITY7_DESC
				8	WoWToken  	WoW Token	ITEM_QUALITY8_DESC
				]]	
				if SLH_itemRarity == 0
				then
					--[[DevMode]]if SLH_NE_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: Item is Poor Quality. Pop-ups disabled for Poor Quality Items.") end
					return
				end				
				
				local SLH_itemID, 
					SLH_itemType, 
					SLH_itemSubType, 
					SLH_itemEquipLoc, 
					SLH_icon, 
					SLH_itemClassID, 
					SLH_itemSubClassID = GetItemInfoInstant(SLH_NE_itemLink) 

				local SLH_itemSlotTable = {
					  ["INVTYPE_AMMO"] =           { 0 },
					  ["INVTYPE_HEAD"] =           { 1 },
					  ["INVTYPE_NECK"] =           { 2 },
					  ["INVTYPE_SHOULDER"] =       { 3 },
					  ["INVTYPE_BODY"] =           { 4 },
					  ["INVTYPE_CHEST"] =          { 5 },
					  ["INVTYPE_ROBE"] =           { 5 },
					  ["INVTYPE_WAIST"] =          { 6 },
					  ["INVTYPE_LEGS"] =           { 7 },
					  ["INVTYPE_FEET"] =           { 8 },
					  ["INVTYPE_WRIST"] =          { 9 },
					  ["INVTYPE_HAND"] =           { 10 },
					  ["INVTYPE_FINGER"] =         { 11, 12 },
					  ["INVTYPE_TRINKET"] =        { 13, 14 },
					  ["INVTYPE_CLOAK"] =          { 15 },
					  ["INVTYPE_WEAPON"] =         { 16, 17 },
					  ["INVTYPE_SHIELD"] =         { 17 },
					  ["INVTYPE_2HWEAPON"] =       { 16 },
					  ["INVTYPE_WEAPONMAINHAND"] = { 16 },
					  ["INVTYPE_WEAPONOFFHAND"] =  { 17 },
					  ["INVTYPE_HOLDABLE"] =       { 17 },
					  ["INVTYPE_RANGED"] =         { 18 },
					  ["INVTYPE_THROWN"] =         { 18 },
					  ["INVTYPE_RANGEDRIGHT"] =    { 18 },
					  ["INVTYPE_RELIC"] =          { 18 }
					}
				
				
				local SLH_EquipableItemReceived = false
				local SLH_EquipableItemSlotID1 = ""
				local SLH_EquipableItemSlotID2 = ""
				
				for key, value in pairs(SLH_itemSlotTable) do 
					if key == SLH_itemEquipLoc
					then
						SLH_EquipableItemReceived = true
						SLH_EquipableItemSlotID1 = value[1]
						if value[2] ~= nil
						then
							SLH_EquipableItemSlotID2 = value[2]	
						else
							SLH_EquipableItemSlotID2 = value[1]								
						end
						--[[DevMode]]if SLH_NE_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("EquipableItemSlotID1 ForLoop: ", SLH_EquipableItemSlotID1) end
						--[[DevMode]]if SLH_NE_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("EquipableItemSlotID2 ForLoop: ", SLH_EquipableItemSlotID2) end
					end
				end		
				
				if not SLH_EquipableItemReceived
				then 
					--[[DevMode]]if SLH_NE_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: Item is not equipable") end
					return 
				end					
				
				--[[				
						SLH_itemType = 4: Armor		
						SLH_itemSubType = 
				Enum					subclassID	itemSubType		Description
				LE_ITEM_ARMOR_GENERIC	0			Miscellaneous	Includes Spellstones, Firestones, Trinkets, Rings and Necks
				LE_ITEM_ARMOR_CLOTH		1			Cloth	
				LE_ITEM_ARMOR_LEATHER	2			Leather	
				LE_ITEM_ARMOR_MAIL		3			Mail	
				LE_ITEM_ARMOR_PLATE		4			Plate	
				LE_ITEM_ARMOR_COSMETIC	5			Cosmetic	
				LE_ITEM_ARMOR_SHIELD	6			Shields	
				LE_ITEM_ARMOR_LIBRAM	7			Librams			Classic
				LE_ITEM_ARMOR_IDOL		8			Idols			Classic
				LE_ITEM_ARMOR_TOTEM		9			Totems			Classic
				LE_ITEM_ARMOR_SIGIL		10			Sigils			Classic
				LE_ITEM_ARMOR_RELIC		11			Relic	
				]]
				local SLH_classIndexTable = {
					"Plate",	--Warrior = 1
					"Plate",	--Paladin = 2
					"Mail",		--Hunter = 3
					"Leather",	--Rogue = 4
					"Cloth",	--Priest = 5
					"Plate",	--DeathKnight = 6
					"Mail",		--Shaman = 7
					"Cloth",	--Mage = 8
					"Cloth",	--Warlock = 9
					"Leather",	--Monk = 10
					"Leather",	--Druid = 11
					"Leather",	--Demon Hunter = 12
					}	
				SLH_localizedClass, SLH_englishClass, SLH_classIndex = UnitClass("player");				
				
				--[[DevMode]]if SLH_NE_DevMode and SLH_itemSubType ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: SLH_itemSubType " .. SLH_itemSubType) end
				--[[DevMode]]if SLH_NE_DevMode and SLH_classIndex ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: SLH_classIndex " .. SLH_classIndex) end
				--[[DevMode]]if SLH_NE_DevMode and SLH_classIndexTable[SLH_classIndex] ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: SLH_classIndexTable[SLH_classIndex] " .. SLH_classIndexTable[SLH_classIndex]) end
							
								
				if SLH_itemType == 4 
					and SLH_itemSubType ~= SLH_classIndexTable[SLH_classIndex] 
					and SLH_itemSubType ~= "Miscellaneous"
					and SLH_itemSubType ~= "Shields"
					and SLH_itemSubType ~= "Librams"
					and SLH_itemSubType ~= "Idols"
					and SLH_itemSubType ~= "Totems"
					and SLH_itemSubType ~= "Sigils"
					and SLH_itemSubType ~= "Relic"
				then
					--[[DevMode]]if SLH_NE_DevMode and SLH_itemSubType ~= nil and SLH_classIndexTable[SLH_classIndex] ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: Armor Not equipped: Armor is ".. SLH_itemSubType .. " not " .. SLH_classIndexTable[SLH_classIndex]) end
					return
				else 
					--[[DevMode]]if SLH_NE_DevMode and SLH_itemSubType ~= nil and SLH_classIndexTable[SLH_classIndex] ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: Armor Matches! ".. SLH_itemSubType .. " is " .. SLH_classIndexTable[SLH_classIndex]) end
				end	
						
				--Returns the item id of the item in the specified inventory slot
					--[[DevMode]]if SLH_NE_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("EquipableItemSlotID1: ", SLH_EquipableItemSlotID1) end
					--[[DevMode]]if SLH_NE_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("EquipableItemSlotID2: ", SLH_EquipableItemSlotID2) end
					local SLH_NE_EquippedItemLink1 = GetInventoryItemLink("player", SLH_EquipableItemSlotID1)
					local SLH_NE_EquippedItemLink2 = GetInventoryItemLink("player", SLH_EquipableItemSlotID2)
					if SLH_NE_EquippedItemLink1 == nil then SLH_NE_EquippedItemLink1 = "NothingEquipped" end
					if SLH_NE_EquippedItemLink2 == nil then SLH_NE_EquippedItemLink2 = SLH_NE_EquippedItemLink1 end

					if SLH_NE_EquippedItemLink1 
					then
						local SLH_NE_Equipped_effectiveILvl1,
							SLH_NE_Equipped_isPreview1,
							SLH_NE_Equipped_baseILvl1 = GetDetailedItemLevelInfo(SLH_NE_EquippedItemLink1)
						
						local SLH_NE_Equipped_effectiveILvl2,
							SLH_NE_Equipped_isPreview2,
							SLH_NE_Equipped_baseILvl2 = GetDetailedItemLevelInfo(SLH_NE_EquippedItemLink2)	
							
						local SLH_NE_Equipped_itemName1, 
							SLH_NE_Equipped_itemLink_GetItemInfo1, 
							SLH_NE_Equipped_itemRarity1, 
							SLH_NE_Equipped__GetItemInfo_itemLevel1, 
							SLH_NE_Equipped_itemMinLevel1, 
							SLH_NE_Equipped_itemType1, -- 4 = Armor
							SLH_NE_Equipped_itemSubType1, 
							SLH_NE_Equipped_itemStackCount1,
							SLH_NE_Equipped_itemEquipLoc1, 
							SLH_NE_Equipped_itemIcon1, 
							SLH_NE_Equipped_itemSellPrice1, 
							SLH_NE_Equipped_itemClassID1, 
							SLH_NE_Equipped_itemSubClassID1, 
							SLH_NE_Equipped_bindType1, 
							SLH_NE_Equipped_expacID1, 
							SLH_NE_Equipped_itemSetID1, 
							SLH_NE_Equipped_isCraftingReagent1 = GetItemInfo(SLH_NE_EquippedItemLink1)
										
						local SLH_NE_Equipped_itemName2, 
							SLH_NE_Equipped_itemLink_GetItemInfo2, 
							SLH_NE_Equipped_itemRarity2, 
							SLH_NE_Equipped__GetItemInfo_itemLevel2, 
							SLH_NE_Equipped_itemMinLevel2, 
							SLH_NE_Equipped_itemType2, -- 4 = Armor
							SLH_NE_Equipped_itemSubType2, 
							SLH_NE_Equipped_itemStackCount2,
							SLH_NE_Equipped_itemEquipLoc2, 
							SLH_NE_Equipped_itemIcon2, 
							SLH_NE_Equipped_itemSellPrice2, 
							SLH_NE_Equipped_itemClassID2, 
							SLH_NE_Equipped_itemSubClassID2, 
							SLH_NE_Equipped_bindType2, 
							SLH_NE_Equipped_expacID2, 
							SLH_NE_Equipped_itemSetID2, 
							SLH_NE_Equipped_isCraftingReagent2 = GetItemInfo(SLH_NE_EquippedItemLink2)	
							
							
						local SLH_NE_Equipped_itemID1, 
							SLH_NE_Equipped_itemType1, 
							SLH_NE_Equipped_itemSubType1, 
							SLH_NE_Equipped_itemEquipLoc1, 
							SLH_NE_Equipped_icon1, 
							SLH_NE_Equipped_itemClassID1, 
							SLH_NE_Equipped_itemSubClassID1 = GetItemInfoInstant(SLH_NE_EquippedItemLink1)

						local SLH_NE_Equipped_itemID2, 
							SLH_NE_Equipped_itemType2, 
							SLH_NE_Equipped_itemSubType2, 
							SLH_NE_Equipped_itemEquipLoc2, 
							SLH_NE_Equipped_icon2, 
							SLH_NE_Equipped_itemClassID2, 
							SLH_NE_Equipped_itemSubClassID2 = GetItemInfoInstant(SLH_NE_EquippedItemLink2) 
						
						-- 2 Hand Weapon Test	
							if SLH_itemEquipLoc == "INVTYPE_2HWEAPON" and SLH_NE_Equipped_itemEquipLoc1 ~= "INVTYPE_2HWEAPON"  
							then
								if SLH_NE_DevMode and SLH_NE_itemLink ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: 1 Hand equipped. Did not Auto Equip: " .. SLH_NE_itemLink) end
								return
							end	
								
							if SLH_itemEquipLoc ~= "INVTYPE_2HWEAPON" and SLH_NE_Equipped_itemEquipLoc1 == "INVTYPE_2HWEAPON"  
							then
								if SLH_NE_DevMode and SLH_NE_itemLink ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: 2 Hand equipped. Did not Auto Equip: " .. SLH_NE_itemLink) end
								return
							end	
							
						--[[DevMode]]if SLH_NE_DevMode and _G_SLH["SLH_SV"][NE_Profile]["NE"]["DisableLowerILevel"] ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE_DisableLowerILevel: " .. _G_SLH["SLH_SV"][NE_Profile]["NE"]["DisableLowerILevel"]) end
						--[[DevMode]]if SLH_NE_DevMode and SLH_NE_EquippedItemLink1 ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE_EquippedItemLink1: " .. SLH_NE_EquippedItemLink1) end
						--[[DevMode]]if SLH_NE_DevMode and SLH_NE_Equipped_itemRarity1 ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE_Equipped_itemRarity1: " .. SLH_NE_Equipped_itemRarity1) end	
						--[[DevMode]]if SLH_NE_DevMode and SLH_NE_Equipped_effectiveILvl1 ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE_Equipped_effectiveILvl1: " .. SLH_NE_Equipped_effectiveILvl1) end	
						--[[DevMode]]if SLH_NE_DevMode and SLH_NE_EquippedItemLink2 ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE_EquippedItemLink2: " .. SLH_NE_EquippedItemLink2) end
						--[[DevMode]]if SLH_NE_DevMode and SLH_NE_Equipped_itemRarity2 ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE_Equipped_itemRarity2: " .. SLH_NE_Equipped_itemRarity2) end	
						--[[DevMode]]if SLH_NE_DevMode and SLH_NE_Equipped_effectiveILvl2 ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE_Equipped_effectiveILvl2: " .. SLH_NE_Equipped_effectiveILvl2) end
						--[[DevMode]]if SLH_NE_DevMode and SLH_itemEquipLoc ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("SLH_itemEquipLoc: " .. SLH_itemEquipLoc) end
						
						--[[DevMode]]if SLH_NE_DevMode and SLH_itemType ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("SLH_itemEquipLoc: " .. SLH_itemType) end
						--[[DevMode]]if SLH_NE_DevMode and SLH_NE_Equipped_itemType1 ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE_Equipped_itemType1: " .. SLH_NE_Equipped_itemType1) end
						--[[DevMode]]if SLH_NE_DevMode and SLH_NE_Equipped_itemType2 ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE_Equipped_itemType2: " .. SLH_NE_Equipped_itemType2) end						
						
						--[[DevMode]]if SLH_NE_DevMode and SLH_itemSubType ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("itemSubType: " .. SLH_itemSubType) end
						--[[DevMode]]if SLH_NE_DevMode and SLH_NE_Equipped_itemSubType1 ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE_Equipped_itemSubType1: " .. SLH_NE_Equipped_itemSubType1) end
						--[[DevMode]]if SLH_NE_DevMode and SLH_NE_Equipped_itemSubType2 ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE_Equipped_itemSubType2: " .. SLH_NE_Equipped_itemSubType2) end						
						
						if SLH_GetDetailedItemLevelInfo_effectiveILvl ~= nil
						then
							SLH_GetDetailedItemLevelInfo_effectiveILvl = tonumber(SLH_GetDetailedItemLevelInfo_effectiveILvl)
							--[[DevMode]]if SLH_NE_DevMode and SLH_GetDetailedItemLevelInfo_effectiveILvl then _G_SLH["SLH_SF"]["Config"]["Print"]("GetDetailedItemLevelInfo_effectiveILvl: " .. SLH_GetDetailedItemLevelInfo_effectiveILvl) end
						else
							SLH_GetDetailedItemLevelInfo_effectiveILvl = 0
						end
												
						if SLH_NE_Equipped_effectiveILvl1 ~= nil
						then
							SLH_NE_Equipped_effectiveILvl1 = tonumber(SLH_NE_Equipped_effectiveILvl1)
							--[[DevMode]]if SLH_NE_DevMode and SLH_NE_Equipped_effectiveILvl1 ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE_Equipped_effectiveILvl1: " .. SLH_NE_Equipped_effectiveILvl1) end
						else
							SLH_NE_Equipped_effectiveILvl1 = 0
						end								
						--[[DevMode]]if SLH_NE_DevMode and SLH_GetDetailedItemLevelInfo_effectiveILvl ~= nil and SLH_NE_Equipped_effectiveILvl1 ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("(SLH_GetDetailedItemLevelInfo_effectiveILvl > SLH_NE_Equipped_effectiveILvl1): (" .. SLH_GetDetailedItemLevelInfo_effectiveILvl .. " > " .. SLH_NE_Equipped_effectiveILvl1 .. ")") end		
						
												
						if SLH_NE_Equipped_effectiveILvl2 ~= nil
						then
							SLH_NE_Equipped_effectiveILvl2 = tonumber(SLH_NE_Equipped_effectiveILvl2)
							--[[DevMode]]if SLH_NE_DevMode and SLH_NE_Equipped_effectiveILvl2 ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE_Equipped_effectiveILvl2: " .. SLH_NE_Equipped_effectiveILvl2) end
						else
							SLH_NE_Equipped_effectiveILvl2 = 0
						end								
						--[[DevMode]]if SLH_NE_DevMode and SLH_GetDetailedItemLevelInfo_effectiveILvl ~= nil and SLH_NE_Equipped_effectiveILvl2 ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("(SLH_GetDetailedItemLevelInfo_effectiveILvl > SLH_NE_Equipped_effectiveILvl2): (" .. SLH_GetDetailedItemLevelInfo_effectiveILvl .. " > " .. SLH_NE_Equipped_effectiveILvl2 .. ")") end		
						
						if _G_SLH["SLH_SV"][NE_Profile]["NE"]["AutoEquipByILevel"] == "Y" and ((SLH_GetDetailedItemLevelInfo_effectiveILvl > SLH_NE_Equipped_effectiveILvl1) or (SLH_GetDetailedItemLevelInfo_effectiveILvl > SLH_NE_Equipped_effectiveILvl2))
						then
						
							if UnitAffectingCombat("player")
							then		
								--[[DevMode]]if SLH_NE_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: Unit is in Combat, added to PostCombatList.") end
								local slh_newEntry = #_G_SLH["SLH_SV"][NE_Profile]["NE"]["PostCombatList"]+1
								_G_SLH["SLH_SV"][NE_Profile]["NE"]["PostCombatList"][slh_newEntry] = {}
								_G_SLH["SLH_SV"][NE_Profile]["NE"]["PostCombatList"][slh_newEntry][1] = SLH_NE_itemLink
								_G_SLH["SLH_SV"][NE_Profile]["NE"]["PostCombatList"][slh_newEntry][2] = SLH_NE_lootstring
								return 							
							--Shield in ItemSlotID1
							elseif SLH_itemSubType == "Shields"	and SLH_NE_Equipped_itemSubType1 ~= "Shields" and SLH_NE_Equipped_itemSubType2 ~= "Shields"
							then
								--[[DevMode]]if SLH_NE_DevMode and SLH_NE_itemLink ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: Shield not currently equipped: " .. SLH_NE_itemLink .. "not equipped") end
								return
							elseif SLH_itemSubType == "Shields" and SLH_NE_Equipped_itemSubType1 == "Shields" and (SLH_GetDetailedItemLevelInfo_effectiveILvl > SLH_NE_Equipped_effectiveILvl1)
							then
								if _G_SLH["SLH_SV"][NE_Profile]["NE"]["IgnoreHeirloomSlots"] == "Y" and SLH_NE_Equipped_itemRarity1 == 7
								then
									_G_SLH["SLH_SF"]["Config"]["Print"]("NE: Ignored Heirloom Slot")
									return	
								else
									securecall(EquipItemByName,SLH_NE_itemLink, SLH_EquipableItemSlotID1)
									if SLH_NE_DevMode and SLH_NE_itemLink ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: Auto Equipped: " .. SLH_NE_itemLink) end
								end
								return		
							--Shield in ItemSlotID2					
							elseif SLH_itemSubType == "Shields" and SLH_NE_Equipped_itemSubType2 == "Shields" and (SLH_GetDetailedItemLevelInfo_effectiveILvl > SLH_NE_Equipped_effectiveILvl2)
							then
								if _G_SLH["SLH_SV"][NE_Profile]["NE"]["IgnoreHeirloomSlots"] == "Y" and SLH_NE_Equipped_itemRarity2 == 7
								then
									_G_SLH["SLH_SF"]["Config"]["Print"]("NE: Ignored Heirloom Slot")
									return	
								else
									securecall(EquipItemByName,SLH_NE_itemLink, SLH_EquipableItemSlotID2)
									if SLH_NE_DevMode and SLH_NE_itemLink ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: Auto Equipped: " .. SLH_NE_itemLink)	end
								end
								return	
							--Equip when only 1 slot
							elseif SLH_EquipableItemSlotID1 == SLH_EquipableItemSlotID2 and (SLH_GetDetailedItemLevelInfo_effectiveILvl > SLH_NE_Equipped_effectiveILvl1)
							then
								if _G_SLH["SLH_SV"][NE_Profile]["NE"]["IgnoreHeirloomSlots"] == "Y" and SLH_NE_Equipped_itemRarity1 == 7
								then
									_G_SLH["SLH_SF"]["Config"]["Print"]("NE: Ignored Heirloom Slot")
									return	
								else
									securecall(EquipItemByName,SLH_NE_itemLink, SLH_EquipableItemSlotID1)
									if SLH_NE_DevMode and SLH_NE_itemLink ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: Auto Equipped: " .. SLH_NE_itemLink)	end
								end
								return
							--Equip when 2 slots - Slot 1 Highest Item Level
							elseif SLH_EquipableItemSlotID1 ~= SLH_EquipableItemSlotID2 and (SLH_NE_Equipped_effectiveILvl1 > SLH_NE_Equipped_effectiveILvl2)
							then
								if _G_SLH["SLH_SV"][NE_Profile]["NE"]["IgnoreHeirloomSlots"] == "Y" and (SLH_NE_Equipped_itemRarity1 == 7 or SLH_NE_Equipped_itemRarity2 == 7)
								then
									_G_SLH["SLH_SF"]["Config"]["Print"]("NE: Ignored Heirloom Slot")	
									return
								else
									PickupInventoryItem(SLH_EquipableItemSlotID1)
									PickupInventoryItem(SLH_EquipableItemSlotID2)
									if SLH_NE_DevMode and SLH_NE_EquippedItemLink1 ~= nil and SLH_NE_EquippedItemLink2 ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: Auto Swapped: " .. SLH_NE_EquippedItemLink1 .. " with " .. SLH_NE_EquippedItemLink2)	end
									securecall(EquipItemByName,SLH_NE_itemLink, SLH_EquipableItemSlotID1)
									if SLH_NE_DevMode and SLH_NE_itemLink ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: Auto Equipped: " .. SLH_NE_itemLink)	end
								end
							--Equip when 2 slots - Slot 2 Highest Item Level
							elseif SLH_EquipableItemSlotID1 ~= SLH_EquipableItemSlotID2 and (SLH_NE_Equipped_effectiveILvl2 >= SLH_NE_Equipped_effectiveILvl1)
							then
								if _G_SLH["SLH_SV"][NE_Profile]["NE"]["IgnoreHeirloomSlots"] == "Y" and SLH_NE_Equipped_itemRarity2 == 7
								then
									_G_SLH["SLH_SF"]["Config"]["Print"]("NE: Ignored Heirloom Slot")	
									return
								else
									securecall(EquipItemByName,SLH_NE_itemLink, SLH_EquipableItemSlotID1)
									if SLH_NE_DevMode and SLH_NE_itemLink ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: Auto Equipped: " .. SLH_NE_itemLink)	end
								end
							end
							return
						--Lower Item level - Do not equip
						elseif _G_SLH["SLH_SV"][NE_Profile]["NE"]["AutoEquipByILevel"] == "Y" 
						then
							if SLH_NE_DevMode and SLH_NE_itemLink ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: Lower Item Level. Did not Auto Equip: " .. SLH_NE_itemLink) end
							return
						--Do not Create Equipable Button - Disabled to lower Item Level selectedS
						elseif _G_SLH["SLH_SV"][NE_Profile]["NE"]["DisableLowerILevel"] == "Y" and (SLH_GetDetailedItemLevelInfo_effectiveILvl < SLH_NE_Equipped_effectiveILvl1)
						then
							--[[DevMode]]if SLH_NE_DevMode and SLH_NE_itemLink ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: Disabled for lower Item Level: " .. SLH_NE_itemLink) end
							return
						--Create Equipable Button
						else
							--[[DevMode]]if SLH_NE_DevMode and SLH_NE_itemLink ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: Creating Equipable Item Icon: " .. SLH_NE_itemLink) end
							
							if UnitAffectingCombat("player")
							then	
								--[[DevMode]]if SLH_NE_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: Unit is in Combat.") end
								C_Timer.After(1, function() _G_SLH["SLH_SF"]["SLH_NE_Delay2"](self, event, SLH_NE_itemLink, SLH_NE_lootstring) end)
								return 
							end		
								
							if _G_SLH["SLH_SV"][NE_Profile]["NE"]["framelevel"] > 10000
							then	
								_G_SLH["SLH_SV"][NE_Profile]["NE"]["framelevel"] = 9000
							else 
								_G_SLH["SLH_SV"][NE_Profile]["NE"]["framelevel"] = _G_SLH["SLH_SV"][NE_Profile]["NE"]["framelevel"] + 1									
							end
							
							local SLH_NE_SecureActionButton = CreateFrame("CheckButton", nil, UIParent, "SecureActionButtonTemplate,ActionButtonTemplate")
							SLH_NE_SecureActionButton:SetPoint("CENTER", UIParent, _G_SLH["SLH_SV"][NE_Profile]["NE"]["xOfs"], _G_SLH["SLH_SV"][NE_Profile]["NE"]["yOfs"])	
							SLH_NE_SecureActionButton:SetAttribute("type1", "item")
							SLH_NE_SecureActionButton:SetAttribute("item", SLH_itemName)
							SLH_NE_SecureActionButton:RegisterForClicks("AnyUp")
							SLH_NE_SecureActionButton:SetSize(40, 40)
							SLH_NE_SecureActionButton:SetFrameLevel(_G_SLH["SLH_SV"][NE_Profile]["NE"]["framelevel"])
								
							local SLH_icon = SLH_NE_SecureActionButton:CreateTexture(nil, "ARTWORK")
							SLH_icon:SetAllPoints(true)
							SLH_icon:SetTexture(GetItemIcon(SLH_itemID))
							SLH_NE_SecureActionButton.icon = SLH_icon										 
							SLH_NE_SecureActionButton:Show()
								
							--Make Dragable
							SLH_NE_SecureActionButton:SetMovable(true)
							SLH_NE_SecureActionButton:EnableMouse(true)					
							SLH_NE_SecureActionButton:RegisterForDrag("LeftButton")
							SLH_NE_SecureActionButton:SetScript("OnDragStart", SLH_NE_SecureActionButton.StartMoving)
							SLH_NE_SecureActionButton:SetScript("OnDragStop", SLH_NE_SecureActionButton.StopMovingOrSizing)
															
							SLH_NE_SecureActionButton:HookScript("OnClick", function (self, button, down) 
									if SLH_NE_DevMode and SLH_NE_itemLink ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: SLH_NE_itemLink" .. SLH_NE_itemLink) end
									C_Timer.After(.2, function() 
										if button == "RightButton" or GetItemCount(SLH_NE_itemLink) == 0
										then
											self:Hide() 
											RegisterAttributeDriver(self,"visibility","[combat]hide;hide")
											if SLH_NE_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: Here1") end
											return	
										else
											C_Timer.After(1, function() 
												if GetItemCount(SLH_NE_itemLink) == 0
												then
													self:Hide() 
													RegisterAttributeDriver(self,"visibility","[combat]hide;hide")
													if SLH_NE_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: Here2") end
													return	
												else
													C_Timer.After(1, function() 
														if GetItemCount(SLH_NE_itemLink) == 0
														then
															self:Hide() 
															RegisterAttributeDriver(self,"visibility","[combat]hide;hide")
															if SLH_NE_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: Here3") end
															return	
														else
															C_Timer.After(1, function() 
																if GetItemCount(SLH_NE_itemLink) == 0
																then
																	self:Hide() 
																	RegisterAttributeDriver(self,"visibility","[combat]hide;hide")
																	if SLH_NE_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: Here4") end
																	return													
																end									
															end)
														end									
													end)
												end									
											end)
										end									
									end)
								end)
					
							SLH_NE_SecureActionButton:HookScript("OnEnter", function(widget)
								GameTooltip:SetOwner(SLH_NE_SecureActionButton, "ANCHOR_RIGHT")
								GameTooltip:SetHyperlink(SLH_NE_itemLink)
								GameTooltip:AddLine("\n\nSLH_NE:\n  Left Click: Equip ".. SLH_NE_itemLink .. "\n  Right Click: Hide Button\n  Hold Left Button and Drag to move to your preferred location.", _G_SLH["SLH_SF"]["SLH_TooltipColors"].r, _G_SLH["SLH_SF"]["SLH_TooltipColors"].g, _G_SLH["SLH_SF"]["SLH_TooltipColors"].b, true)
								GameTooltip:Show()
							end)
							SLH_NE_SecureActionButton:HookScript("OnLeave", function(widget) 
								GameTooltip:Hide()
								local SLH_point, SLH_relativeTo, SLH_relativePoint,SLH_xOfs, SLH_yOfs = SLH_NE_SecureActionButton:GetPoint(n)
								
								_G_SLH["SLH_SV"][NE_Profile]["NE"]["xOfs"] = SLH_xOfs
								_G_SLH["SLH_SV"][NE_Profile]["NE"]["yOfs"] = SLH_yOfs
							end)
										
							RegisterAttributeDriver(SLH_NE_SecureActionButton,"visibility","[combat]hide;show")
							
							return 
						end
					end
				return
			end

		--SLH_NE_Delay
			local SLH_NE_Delay = function (self, event, ...)	
				--[[DevMode]]if SLH_NE_DevMode and event ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE_Delay event: " .. event) end
				if event == "MAIL_SHOW" 
				then  
					_G_SLH["SLH_SV"][NE_Profile]["NE"]["PausedWhileMailing"] = "Y"
					return 
				elseif event == "MAIL_CLOSED" 
				then  
					_G_SLH["SLH_SV"][NE_Profile]["NE"]["PausedWhileMailing"] = "N"
					return 
				end	
				--[[DevMode]]if SLH_NE_DevMode and _G_SLH["SLH_SV"][NE_Profile]["NE"]["PausedWhileMailing"] ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE_Delay PausedWhileMailing: " .. _G_SLH["SLH_SV"][NE_Profile]["NE"]["PausedWhileMailing"]) end
				if _G_SLH["SLH_SV"][NE_Profile]["NE"]["DisableWhenMailBoxIsOpen"] == "Y" and _G_SLH["SLH_SV"][NE_Profile]["NE"]["PausedWhileMailing"] == "Y" then return end	
				if IsAltKeyDown() then return end
			
				local SLH_NE_lootstring, 
					SLH_playerName , 
					SLH_languageName , 
					SLH_channelName , 
					SLH_playerName2 , 
					SLH_specialFlags , 
					SLH_zoneChannelID , 
					SLH_channelIndex , 
					SLH_channelBaseName , 
					unused , 
					SLH_lineID , 
					SLH_SenderGUID, 
					SLH_bnSenderID , 
					SLH_isMobile  , 
					SLH_isSubtitle  , 
					SLH_hideSenderInLetterbox  , 
					SLH_supressRaidIcons  = ...
				local SLH_NE_itemLink = string.match(SLH_NE_lootstring,"|%x+|Hitem:.-|h.-|h|r")
				local SLH_UnitName = string.gsub(UnitName("player"), " ", "")
				local SLH_realmName = string.gsub(GetRealmName(), " ", "")
				local SLH_UnitName_realmName = SLH_UnitName .. "-" .. SLH_realmName
				SLH_playerName = string.gsub(SLH_playerName, " ", "")
				
				if SLH_UnitName_realmName ~= SLH_playerName then return end
				
				if _G_SLH["SLH_SV"][NE_Profile]["NE"]["DisableForCrafting"] == "Y" and string.find(SLH_NE_lootstring, "You create") then return end
				--[[DevMode]]if SLH_NE_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NE_Delay: Not a Crafted Item") end		
				
				if _G_SLH["SLH_SV"][NE_Profile]["NE"]["DisableWhenMailBoxIsOpen"] == "Y" and MailFrame:IsVisible() then return end
				--[[DevMode]]if SLH_NE_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NE_Delay: Not a Mailed Item") end
				
				
				C_Timer.After(1, function() SLH_NE_Module(self, event, SLH_NE_itemLink, SLH_NE_lootstring) end) 
			end

		--SLH_NE_Delay2
			_G_SLH["SLH_SF"]["SLH_NE_Delay2"] = function (self, event, SLH_NE_itemLink, SLH_NE_lootstring)
				if UnitAffectingCombat("player")
				then	
					--[[DevMode]]if SLH_NE_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: Unit is in Combat.") end
					C_Timer.After(1, function() _G_SLH["SLH_SF"]["SLH_NE_Delay2"](self, event, SLH_NE_itemLink, SLH_NE_lootstring) end)
					return 
				else 
					C_Timer.After(1, function() SLH_NE_Module(self, event, SLH_NE_itemLink, SLH_NE_lootstring) end)			
					return 
				end
			end

		--SLH_NE_PostCombat
			_G_SLH["SLH_SF"]["SLH_NE_PostCombat"] = function (self, event, SLH_NE_itemLink, SLH_NE_lootstring)				
				if next(_G_SLH["SLH_SV"][NE_Profile]["NE"]["PostCombatList"]) ~= nil
				then
					for i=#_G_SLH["SLH_SV"][NE_Profile]["NE"]["PostCombatList"],1,-1 do	
						C_Timer.After(1, function() 
							if _G_SLH["SLH_SV"][NE_Profile]["NE"]["PostCombatList"][i] ~= nil
							then				
								local SLH_NE_itemLink = _G_SLH["SLH_SV"][NE_Profile]["NE"]["PostCombatList"][i][1]
								local SLH_NE_lootstring = _G_SLH["SLH_SV"][NE_Profile]["NE"]["PostCombatList"][i][2]
								--[[DevMode]]if SLH_NE_DevMode and i ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: PostCombat index = " .. i) end	
								--[[DevMode]]if SLH_NE_DevMode and SLH_NE_itemLink ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: PostCombat SLH_NE_itemLink = " .. SLH_NE_itemLink) end	
								--[[DevMode]]if SLH_NE_DevMode and SLH_NE_lootstring ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE: PostCombat SLH_NE_lootstring = " .. SLH_NE_lootstring) end									
								if _G_SLH["SLH_SV"][NE_Profile]["NE"]["PostCombatList"][i][1] ~= nil and _G_SLH["SLH_SV"][NE_Profile]["NE"]["PostCombatList"][i][2]
								then	
									_G_SLH["SLH_SF"]["SLH_NE_Delay2"](self, event, SLH_NE_itemLink, SLH_NE_lootstring) 	
								end								
							end 
							_G_SLH["SLH_SV"][NE_Profile]["NE"]["PostCombatList"][i][1] = nil;
							_G_SLH["SLH_SV"][NE_Profile]["NE"]["PostCombatList"][i][2] = nil;
							_G_SLH["SLH_SV"][NE_Profile]["NE"]["PostCombatList"][i]	 = nil;
							return
						end)
					end	
					return	
				end 	
			end


		--SLH_NC Module Scan
			_G_SLH["SLH_SF"]["SLH_NE_Scan"] = function (self, event, ...)	
		
				--[[DevMode]]if SLH_NE_DevMode then _G_SLH["SLH_SF"]["Config"]["Print"]("NC: SLH_NE_Module_Scan Start") end		
				local SLH_Bags = {}	
				SLH_Bags[1]=0
				SLH_Bags[2]=1
				SLH_Bags[3]=2
				SLH_Bags[4]=3
				SLH_Bags[5]=4
				for index, SLH_bagID in ipairs(SLH_Bags) do
					local SLH_Bag_numberOfSlots = GetContainerNumSlots(SLH_bagID)
					for SLH_slot = 1, SLH_Bag_numberOfSlots do
						local SLH_icon, 
							SLH_itemCount,
							SLH_locked, 
							SLH_quality, 
							SLH_readable, 
							SLH_lootable, --Lockbox ID?
							SLH_itemLink, 
							SLH_isFiltered, 
							SLH_noValue, 
							SLH_itemID = GetContainerItemInfo(SLH_bagID, SLH_slot)
							
						if SLH_itemLink ~= nil
						then 
							local SLH_NE_lootstring = string.match(SLH_itemLink, "item[%-?%d:]+")
							SLH_NE_Module(self, event, SLH_itemLink, SLH_NE_lootstring)
						end
					end
				end
				return
			end
			

		--SLH_NE EventCall
			local SLH_NE_Events = function (SLH_NEOptions, event, name, ...)
				--[[DevMode]]if SLH_NE_DevMode and event ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE event: " .. event) end
				--[[DevMode]]if SLH_NE_DevMode and UnitLevel("player") ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("NE UnitLevel: " .. UnitLevel("player")) end
				if _G_SLH["SLH_SV"][NE_Profile]["NE"]["DisableAtMaxLevel"] == "Y" and UnitLevel("player") == 60 then return end
					
				_G_SLH["SLH_SV"][NE_Profile]["NE"]["PausedWhileMailing"] = "N"
				
				
				Run_SLH_NE = CreateFrame("Frame","Run_SLH_NE")
				Run_SLH_NE:RegisterEvent("CHAT_MSG_LOOT")	
				Run_SLH_NE:RegisterEvent("MAIL_SHOW")		
				Run_SLH_NE:RegisterEvent("MAIL_CLOSED")			
				if _G_SLH["SLH_SV"][NE_Profile]["NE"]["Enable"] == "Y"
					then Run_SLH_NE:HookScript("OnEvent", SLH_NE_Delay)
				end
				
				Run_SLH_NE_PostCombat= CreateFrame("Frame","Run_SLH_NE_PostCombat")
				Run_SLH_NE_PostCombat:RegisterEvent("PLAYER_REGEN_ENABLED")		
				if _G_SLH["SLH_SV"][NE_Profile]["NE"]["Enable"] == "Y"
				then 
					Run_SLH_NE_PostCombat:HookScript("OnEvent", function (self, event, ...)		
						_G_SLH["SLH_SF"]["SLH_NE_PostCombat"](self, event, ...)	
					end)
				end
								
				if _G_SLH["SLH_SV"][NE_Profile]["NE"]["LogOnScan"] == "Y"
				then
					Run_SLH_NE_Scan = CreateFrame("Frame","Run_SLH_NE_Scan")
					Run_SLH_NE_Scan:RegisterEvent("PLAYER_ENTERING_WORLD")		
					if _G_SLH["SLH_SV"][NE_Profile]["NE"]["Enable"] == "Y"
					then 
						Run_SLH_NE_Scan:HookScript("OnEvent", function (self, event, ...)		
							_G_SLH["SLH_SF"]["SLH_NE_Scan"](self, event, ...)	
						end)
					end
				end
			end

		--SLH_NE Config Screen
			local SLH_NE_Frames = function  (self, event, name, ...)

				-- SLH_NE Options
					local SLH_NEOptions = CreateFrame( "Frame", "SLH_NEOptions")
					SLH_NEOptions.name = "New Equipables"
					-- Specify childness of this panel (this puts it under the little red [+], instead of giving it a normal AddOn category)
						SLH_NEOptions.parent = SLH_Config_Panel.name
					-- Add the child to the Interface Options
						InterfaceOptions_AddCategory(SLH_NEOptions)
					--Add Title
						local SLH_NEOptionsTitle = SLH_NEOptions:CreateFontString(nil, "ARTWORK","GameFontNormalLarge")
						SLH_NEOptionsTitle:SetPoint("TOPLEFT", 10, -10)
						SLH_NEOptionsTitle:SetText("Salen's Little Helper - New Equipables Options")

			
				--SLH_NEDetail - Create Scroll Frame		
					SLH_NEDetail = securecall(_G_SLH["SLH_SF"]["SLH_CreateScrollFrame"],SLH_NEOptions, --self
						"SLH_NEDetail", --FrameName
						SLH_NEOptions, --relativeFrame
						5, --xOffset
						-30, --yOffset
						SLH_NEOptions, --relativeFrame
						-5, --xOffset
						5,--yOffset
						"New Equipables Options" -- Title
						)
					SLH_NEDetail.ScrollBar:ClearAllPoints()
					SLH_NEDetail.ScrollBar:SetPoint("TOPLEFT", SLH_NEDetail, "TOPRIGHT", -25, -20)
					SLH_NEDetail.ScrollBar:SetPoint("BOTTOMRIGHT", SLH_NEDetail, "BOTTOMRIGHT", -5, 25)
					SLH_NEDetail:SetClipsChildren(true)		
					
					--(Uncomment to) Set Background Color
						--SLH_NEDetail.bg = SLH_NEDetail:CreateTexture(nil, "BACKGROUND")
						--SLH_NEDetail.bg:SetAllPoints(true)
						--SLH_NEDetail.bg:SetColorTexture(0.8, 0.4, 0, 0.2)
					--End Set Background Color

					--SLH_NEDetailScrollFrameChild
						local SLH_NEDetailScrollFrameChild = CreateFrame("Frame", nil, SLH_NEDetail)
						SLH_NEDetailScrollFrameChild:SetSize(600, 470)
							--(Uncomment to) Set Background Color
								--SLH_NEDetailScrollFrameChild.bg = SLH_NEDetailScrollFrameChild:CreateTexture(nil, "BACKGROUND")
								--SLH_NEDetailScrollFrameChild.bg:SetAllPoints(true)
								--SLH_NEDetailScrollFrameChild.bg:SetColorTexture(0.2, 0.6, 0, 0.8)
							--End Set Background Color
						SLH_NEDetail:SetScrollChild(SLH_NEDetailScrollFrameChild)	
						SLH_NEDetailScrollFrameChild:SetClipsChildren(true)		
			
					

					--SLH_NEDetail Title 
						SLH_NEDetailScrollFrameChild.title = SLH_NEDetailScrollFrameChild:CreateFontString (nil, "OVERLAY")
						SLH_NEDetailScrollFrameChild.title:SetFontObject("GameFontHighlight")
						SLH_NEDetailScrollFrameChild.title:SetPoint("LEFT", SLH_NEDetailScrollFrameChild.TitleBg, "LEFT", 5, 0)
						SLH_NEDetailScrollFrameChild.title:SetText("New Equipables Options")	
						SLH_NEDetailScrollFrameChild.title:SetTextColor(_G_SLH["SLH_SF"]["SLH_TitleColors"].r, _G_SLH["SLH_SF"]["SLH_TitleColors"].g, _G_SLH["SLH_SF"]["SLH_TitleColors"].b, _G_SLH["SLH_SF"]["SLH_TitleColors"].a)					

					--MasterFrame.SLH_NEDetail Buttons
						-- Enable_SLH_NE Check Button:
							Enable_SLH_NE = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_NEOptions, --self
								"TOPLEFT", --point
								SLH_NEDetailScrollFrameChild, --relativeFrame
								"Enable_SLH_NE", --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								10, --xOffset
								-20, --yOffset
								"SLH_SV", --SVPath0
								NE_Profile, --SVPath1
								"NE", --SVPath2
								"Enable", --SVPath3
								"Enable New Equipables", --text
								"Creates a PopUp Icon for using the new Equipable\n\nLeft Click to Use it, Right Click to Close the icon.\n\nIcon will Automatically Hide During Combat." --tooltip
								)
								Enable_SLH_NE:HookScript("OnClick", function(self, arg1)			
									if Enable_SLH_NE:GetChecked() 
										then 
											_G_SLH["SLH_SV"][NE_Profile]["NE"]["Enable"] = "Y"
											SLH_NE_SetVars(self, event, name)
											SLH_NE_Events(self, event, name)
										else 
											_G_SLH["SLH_SV"][NE_Profile]["NE"]["Enable"] = "N"
											--if _G_SLH["SLH_SV"][NE_Profile]["NE"]["DisableAtMaxLevel"] == "Y" and UnitLevel("player") == 60 then return end
											
											if Run_SLH_ActiveQuests then Run_SLH_ActiveQuests:UnregisterAllEvents()	end
											if Run_SLH_CompleteQuests then Run_SLH_CompleteQuests:UnregisterAllEvents()	end
											if Run_SLH_AvailableQuests then Run_SLH_AvailableQuests:UnregisterAllEvents()	end
											if Run_SLH_AcceptQuests then Run_SLH_AcceptQuests:UnregisterAllEvents()	end				
									end
								end)
										
						-- SLH_NE_SLH_xOfs - in seconds
							SLH_NE_SLH_xOfs = securecall(_G_SLH["SLH_SF"]["SLH_CreateSlider"],SLH_NEOptions, --
								"TOPLEFT", --point
								Enable_SLH_NE, --relativeFrame
								"SLH_NE_SLH_xOfs" , --FrameName
								"BOTTOMLEFT", --relativePoint
								10, --xOffset
								-40, --yOffset
								-1000, --Min
								1000, --Max
								_G_SLH["SLH_SV"][NE_Profile]["NE"]["xOfs"], --Value
								20, --Step
								"SLH_SV", --SVPath0
								NE_Profile, --SVPath1
								"NE", --SVPath2
								"xOfs", --SVPath3
								"Set X Coordinate?", --text
								"Set X Coordinate\n\nThis is in case the button is moved off screen and you need to recover it.\n\nCoordinates are from center of the screen. Center = 0 , Default = 0\n\nThis setting requires a reload after a change." --tooltip
								)
										
						-- SLH_NE_SLH_yOfs - in seconds
							SLH_NE_SLH_yOfs = securecall(_G_SLH["SLH_SF"]["SLH_CreateSlider"],SLH_NEOptions, --
								"TOPLEFT", --point
								SLH_NE_SLH_xOfs, --relativeFrame
								"SLH_NE_SLH_yOfs" , --FrameName
								"BOTTOMLEFT", --relativePoint
								0, --xOffset
								-50, --yOffset
								-1000, --Min
								1000, --Max
								_G_SLH["SLH_SV"][NE_Profile]["NE"]["yOfs"], --Value
								20, --Step
								"SLH_SV", --SVPath0
								NE_Profile, --SVPath1
								"NE", --SVPath2
								"yOfs", --SVPath3
								"Set Y Coordinate?", --text
								"Set Y Coordinate\n\nThis is in case the button is moved off screen and you need to recover it.\n\nCoordinates are from center of the screen. Center = 0 , Default = 320\n\nThis setting requires a reload after a change." --tooltip
								)
								
						-- SLH_NE_DisableForCrafting - in seconds								
							SLH_NE_DisableForCrafting = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_NEOptions, --self
								"TOPLEFT", --point
								SLH_NE_SLH_yOfs, --relativeFrame
								"SLH_NE_DisableForCrafting", --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								0, --xOffset
								-40, --yOffset
								"SLH_SV", --SVPath0
								NE_Profile, --SVPath1
								"NE", --SVPath2
								"DisableForCrafting", --SVPath3
								"Disable when you Craft the item?", --text
								"Disables when you Craft the item\n\nPrevents auto equipping crafted items." --tooltip
								)
								
						-- SLH_NE_SLH_yOfs - in seconds								
							SLH_NE_DisableWhenMailBoxIsOpen = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_NEOptions, --self
								"TOPLEFT", --point
								SLH_NE_DisableForCrafting, --relativeFrame
								"SLH_NE_DisableWhenMailBoxIsOpen", --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								0, --xOffset
								-20, --yOffset
								"SLH_SV", --SVPath0
								NE_Profile, --SVPath1
								"NE", --SVPath2
								"DisableWhenMailBoxIsOpen", --SVPath3
								"Disable when Mailbox is open?", --text
								"Disables when Mailbox is open.\n\nPrevents auto equipping items received in the mail." --tooltip
								)
								
						-- SLH_NE_DisableBOE Check Button:
							SLH_NE_DisableBOE = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_NEOptions, --self
								"TOPLEFT", --point
								SLH_NE_DisableWhenMailBoxIsOpen, --relativeFrame
								"SLH_NE_DisableBOE", --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								0, --xOffset
								-40, --yOffset
								"SLH_SV", --SVPath0
								NE_Profile, --SVPath1
								"NE", --SVPath2
								"DisableBOE", --SVPath3
								"Disable for BOE Items?", --text
								"Disables for BOE Items\n\nDefault = Yes\n\nPrevents accidentally equipping an item you may want to sell." --tooltip
								)
								
						-- SLH_NE_DisableLowerILevel Check Button:
							SLH_NE_DisableLowerILevel = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_NEOptions, --self
								"TOPLEFT", --point
								SLH_NE_DisableBOE, --relativeFrame
								"SLH_NE_DisableLowerILevel", --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								0, --xOffset
								-20, --yOffset
								"SLH_SV", --SVPath0
								NE_Profile, --SVPath1
								"NE", --SVPath2
								"DisableLowerILevel", --SVPath3
								"Disable for Lower Item level?", --text
								"Disables for item with a Lower Item Level than currently Equipped\n\nDefault = Yes\n\nPrevents pop-ups for items you likely don't want to equip." --tooltip
								)
								
						-- SLH_NE_AutoEquipByILevel Check Button:
							SLH_NE_AutoEquipByILevel = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_NEOptions, --self
								"TOPLEFT", --point
								SLH_NE_DisableLowerILevel, --relativeFrame
								"SLH_NE_AutoEquipByILevel", --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								0, --xOffset
								-40, --yOffset
								"SLH_SV", --SVPath0
								NE_Profile, --SVPath1
								"NE", --SVPath2
								"AutoEquipByILevel", --SVPath3
								"Auto Equip when Higher Item Level?", --text
								"Auto Equips when Higher Item Level\n\nDefault = Yes\n\nPrevents Pop-up altogether, just shows a chat message and equips item. Good for Lazy Levelling. Disable for MinMaxing." --tooltip
								)
								
						-- SLH_NE_IgnoreHeirloomSlots Check Button:
							SLH_NE_IgnoreHeirloomSlots = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_NEOptions, --self
								"TOPLEFT", --point
								SLH_NE_AutoEquipByILevel, --relativeFrame
								"SLH_NE_IgnoreHeirloomSlots", --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								0, --xOffset
								-20, --yOffset
								"SLH_SV", --SVPath0
								NE_Profile, --SVPath1
								"NE", --SVPath2
								"IgnoreHeirloomSlots", --SVPath3
								"Ignore Heirloom Slots?", --text
								"Ignore Heirloom Slots\n\nDefault = Yes\n\nSlots equipped with Heirlooms will not have gear Auto Equipped." --tooltip
								)
						
								
						--Right Side
								
						-- SLH_NE_DisableAtMaxLevel Check Button:
							SLH_NE_DisableAtMaxLevel = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_NEOptions, --self
								"TOPLEFT", --point
								Enable_SLH_NE, --relativeFrame
								"SLH_NE_DisableAtMaxLevel", --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								280, --xOffset
								0, --yOffset
								"SLH_SV", --SVPath0
								NE_Profile, --SVPath1
								"NE", --SVPath2
								"DisableAtMaxLevel", --SVPath3
								"Disable New Equipables at Max Level?", --text
								"Disables New Equipables when you character reaches Max Level for your account\n\nAllows you to keep your current settings and not worry about lost quest rewards at max level.\n\nThis setting requires a reload after a change." --tooltip
								)
								
						-- SLH_NE_LogOnScan Check Button:
							SLH_NE_LogOnScan = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_NEOptions, --self
								"TOPLEFT", --point
								SLH_NE_DisableAtMaxLevel, --relativeFrame
								"SLH_NE_LogOnScan", --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								0, --xOffset
								-20, --yOffset
								"SLH_SV", --SVPath0
								NE_Profile, --SVPath1
								"NE", --SVPath2
								"LogOnScan", --SVPath3
								"Run Scan on Loading UI?", --text
								"Runs Scan when Loading UI.\n\nObeys all other NewEquipables Settings." --tooltip
								)
								
										
			end

				
			if _G_SLH["SLH_PCSV"][SLH_PCSV_UnitName]["Config"]["NE_Load"] == "Y" then
				SLH_NE_SetVars(self, event, name, ...)
				SLH_NE_Events(self, event, name, ...)
			end
			if _G_SLH["SLH_PCSV"][SLH_PCSV_UnitName]["Config"]["NE_Hide"] == "N" then
				SLH_NE_Frames(self, event, name, ...)
			end
		
	end	)	